/*
 *	SCCS:		%W%		%G%		%U%
 *
 *	Last Modified :	<990714.0750>
 *
 *	EDEF:		Global variable definitions for
 *			MicroEMACS 3.2
 *
 *			written by Dave G. Conroy
 *			modified by Steve Wilhite, George Jones
 *			greatly modified by Daniel Lawrence
 * 
 ****************************************************************************
 * 
 * Modifications to the original file by Jasspa. 
 * 
 * Copyright (C) 1988 - 1999, JASSPA 
 * The MicroEmacs Jasspa distribution can be copied and distributed freely for
 * any non-commercial purposes. The MicroEmacs Jasspa Distribution can only be
 * incoportated into commercial software with the expressed permission of
 * JASSPA.
 * 
 ****************************************************************************/

/* initialized global external declarations */

extern  meDIRLIST       curDirList ;
extern  struct osdDIALOG  *osdDialogHd;  /* Root of the on screen displays */
extern  struct osdDISPLAY *osdDisplayHd; /* Menu display list */
extern  meREGISTERS    *meRegHead;      /* The register Head            */
extern  meREGISTERS    *meRegCurr;      /* The current register set     */
extern  SELHILIGHT      selhilight;     /* Selection hilight            */
extern  HILCOLOR       *hilCol;         /* Hilighting colour changes    */
extern  int             colSchmTblSize; /* Size of the colour table     */
extern  unsigned char  *colSchmTbl;     /* Highlighting colour table    */
#ifdef _TCAPFONT
extern  unsigned char  *fntSchmTbl;     /* Highlighting colour table    */
#endif
#if ABREV
extern  meABREV        *globalAbrev ;   /* Global Abreviation file	*/
#endif
extern  unsigned short  hilColS ;       /* Hilighting - col chng ary sz */
extern  unsigned char  *disLineBuff ;   /* interal display buffer array */
extern  int     disLineSize ;           /* interal display buffer size  */
extern  int     cursorState ;           /* Current state of cursor      */
extern  FRAMELINE       *frameStore;    /* Frame store line pointers    */
extern  char   *progName ;              /* the program name (argv[0])   */
extern  char  **ModeLineStr ;           /* modeline line format         */
extern  char    orgModeLineStr[] ;      /* original modeline line format*/
extern  char   *modeLineStr ;           /* current modeline format      */
extern  unsigned char modeLineFlags ;   /* current modeline flags       */
extern  int     autotime;               /* auto save time in seconds    */
extern  int     keptVersions;           /* No. of kept backup versions  */
extern  unsigned long delaytime;        /* mouse-time delay time        */
extern  unsigned long repeattime;       /* mouse-time repeat time       */
extern  unsigned long idletime;         /* idle-time delay time         */
extern  char    fillbullet[];           /* Fill bullet character class  */
extern  short   fillbulletlen;          /* Fill lookahead limit         */
extern  short   fillcol;                /* Fill column                  */
extern  char    filleos[];              /* Fill E-O-S character class   */
extern  short   filleoslen;             /* Fill E-O-S ' ' insert len    */
extern  char    fillignore[];           /* Fill Ignore character class  */
extern  unsigned short	tabsize;  	/* Virtual Tab size             */
extern  unsigned short	tabwidth;       /* Real TAB size                */
extern  short   matchlen;               /* Fence matching delay length  */
extern  char	*homedir;             	/* Home directory               */
extern  char	*searchPath;           	/* emf search path              */
extern  char	*curdir;             	/* current working directory    */
extern	char	*execstr;		/* pointer to string to execute */
extern	int	execlevel;		/* execution IF level		*/
extern	int	bufHistNo;		/* inc buff hist numbering      */
extern  int     lastCommand ;           /* The last user executed key   */
extern  int     lastIndex ;             /* The last user executed comm  */
extern  int     thisCommand ;           /* The cur. user executed key   */
extern  int     thisIndex ;             /* The cur. user executed comm  */
extern  int     thisF ;                 /* The cur. user comm args      */
extern  int     thisN ;                 /* The cur. user comm args      */
extern  char	hexdigits[];
extern  short   keyTableSize;           /* The current size of the key table */
extern	KEYTAB	keytab[];		/* key bind to functions table	*/
extern  int     cmdTableSize;           /* The current size of the command table */
extern	meCMD **cmdTable;		/* command table                */
extern	meCMD  *cmdHead;		/* command alpha list head      */
extern  unsigned char commandFlag[] ;
extern  char          fillmode;         /* Justify mode                 */
extern  unsigned char scrollFlag ;      /* horiz/vert scrolling method  */
extern  unsigned char sgarbf;           /* State of screen unknown      */
extern	unsigned char clexec;		/* command line execution flag	*/
extern	unsigned char mcStore;		/* storing text to macro flag	*/
extern	unsigned char cmdstatus;	/* last command status		*/
extern	unsigned char kbdmode;		/* current keyboard macro mode	*/
extern	signed   char macbug; 		/* macro debuging flag		*/
extern  unsigned char thisflag;         /* Flags, this command          */
extern  unsigned char lastflag;         /* Flags, last command          */
extern  unsigned char lastReplace;      /* set to non-zero if last was a replace */

extern  unsigned long meSystemCfg;      /* ME system config variable    */
#define meSYSTEM_CONSOLE    0x00001     /* This is a console version    */
#define meSYSTEM_RGBCOLOR   0x00002     /* System has definable rgb color */
#define meSYSTEM_ANSICOLOR  0x00004     /* Ansi standard color (8 colors) */
#define meSYSTEM_XANSICOLOR 0x00008     /* Extended Ansi colors (16)    */
#define meSYSTEM_FONTS      0x00010     /* Use termcap fonts (bold etc) */
#define meSYSTEM_UNIXSYSTEM 0x00080     /* This is a unix sys           */
#define meSYSTEM_MSSYSTEM   0x00100     /* This is a dos or win32 sys   */
#define meSYSTEM_DRIVES     0x00200     /* This system has drives (C:\) */
#define meSYSTEM_DOSFNAMES  0x00400     /* Dos 8.3 file name restriction*/
#define meSYSTEM_IPIPES     0x00800     /* The system supports ipipes   */
#define meSYSTEM_TABINDALW  0x01000     /* Tab key indents always       */
#define meSYSTEM_ALTMENU    0x02000     /* Enable Alt as menu hot key   */
#define meSYSTEM_ALTPRFX1   0x04000     /* Enable Alt as prefix1        */
#define meSYSTEM_KEEPUNDO   0x08000     /* Keep undo history after save */
#define meSYSTEM_FONTFIX    0x10000     /* Enables ANSI 0-31 rendering  */
#define meSYSTEM_CLNTSRVR   0x20000     /* Enables the client server    */
#define meSYSTEM_CTCHASPC   0x40000     /* Enables win32 catch A-space  */

#ifdef _UNIX
#ifdef _CLIENTSERVER
#define meSYSTEM_MASK (meSYSTEM_ANSICOLOR|meSYSTEM_XANSICOLOR|meSYSTEM_FONTS|meSYSTEM_DOSFNAMES|meSYSTEM_IPIPES|meSYSTEM_TABINDALW|meSYSTEM_ALTMENU|meSYSTEM_ALTPRFX1|meSYSTEM_KEEPUNDO|meSYSTEM_FONTFIX|meSYSTEM_CLNTSRVR)
#else
#define meSYSTEM_MASK (meSYSTEM_ANSICOLOR|meSYSTEM_XANSICOLOR|meSYSTEM_FONTS|meSYSTEM_DOSFNAMES|meSYSTEM_IPIPES|meSYSTEM_TABINDALW|meSYSTEM_ALTMENU|meSYSTEM_ALTPRFX1|meSYSTEM_KEEPUNDO|meSYSTEM_FONTFIX)
#endif
#endif
#ifdef _DOS
#define meSYSTEM_MASK (meSYSTEM_TABINDALW|meSYSTEM_ALTMENU|meSYSTEM_ALTPRFX1|meSYSTEM_KEEPUNDO)
#endif
#ifdef _WIN32
extern  unsigned long meSYSTEM_MASK;    /* ME system mask - dependant on win32 flavour */
#endif

#if MOUSE
extern  unsigned long meMouseCfg;       /* ME mouse config variable     */
#define meMOUSE_NOBUTTONS   0x0000f     /* # mouse buttons              */
#define meMOUSE_ENBLE       0x00010     /* mouse is enabled             */
#define meMOUSE_SWAPBUTTONS 0x00020     /* swap mouse buttons           */
#define meMOUSE_ICON        0xf0000     /* Mask to set the mouse pointer icon */
#endif

#if MEUNDO
extern  unsigned long undoContFlag;     /* continuation of an undo      */
#endif
#if (defined _DOS) || (defined _WIN32)
extern  unsigned short meUmask ;        /* file creation umask          */
#endif
#ifdef _UNIX
extern  unsigned short meUmask ;        /* file creation umask          */
extern  uid_t          meUid ;          /* current user id              */
extern  gid_t          meGid ;          /* current group id             */
extern  sigset_t       meSigHoldMask ;  /* signals help when spawning and reading */
#endif

#ifdef _IPIPES
/* Incremental pipe variables */
extern IPIPEBUF *ipipes ;               /* list of all the current pipes*/
extern int       noIpipes ;             /* count of all the cur pipes   */ 
#endif

extern  short alarmState;               /* Auto-save alarm time         */
extern  long  startTime;                /* me start time. used as offset*/
extern  short mouse_X;                  /* mouse X pos at last event    */
extern  short mouse_Y;                  /* mouse X pos at last event    */
extern  short mouse_dX;                 /* mouse delta X last event pos */
extern  short mouse_dY;                 /* mouse delta X last event pos */
extern  unsigned char  mouse_pos;       /* mouse virtual position       */
extern  LINE   *menuLine ;              /* Menu-poke line */
extern	LINE   *lpStore;		/* line off which to store macro*/
extern  LINE    helpStore;      	/* line off which help is stores*/
extern  unsigned short thiskey;         /* the current key              */
extern	int	taboff; 		/* tab offset for display	*/
extern	unsigned short prefixc[];       /* prefix chars           */
extern	unsigned short reptc;		/* current universal repeat char*/
#ifdef _CLIPBRD
/* When implementing the clipboard it is best if the clipboard is only
 * attempted to be got or set once per command. This is because of other
 * window interaction.
 * 
 * If the command is a macro the the following nasty things can happen if this
 * is not so
 * 
 * 1) The 1st yank in a macro may return a different value to the 2nd yank, if
 *    the user defines another region in a different window.
 * 
 * 2) If the macro is looping round cutting and pasting then the user will now
 *    be able to reliably cut 'n' paste in another window.
 * 
 * 3) A macro could cut a region and the paste a different one!
 * 
 * Nasty. Try and ensure these don't happen.
 */

extern  unsigned char clipState;        /* clipboard status flag        */
#define CLIP_TRY_GET 0x01               /* We can try and get the clipbd*/
#define CLIP_TRY_SET 0x02               /* We can try and set the clipbd*/
#define CLIP_OWNER   0x04               /* We are the owners of clipbrd */
#endif
extern  unsigned long cursorBlink ;     /* cursor-blink blink time      */
extern  int     blinkState ;            /* cursor blink state           */
#if COLOR
extern  int     cursorColor;            /* cursor-color scheme          */
extern  int     osdScheme;              /* Menu line color scheme       */
extern  int     mlScheme;               /* Message line color scheme    */
extern  int     mdLnScheme;             /* Mode line color scheme       */
extern  int     sbarScheme;             /* Scroll bar color scheme      */
extern  int     globScheme;             /* Global color scheme          */
extern  int     gsbarmode;              /* global scroll bar mode       */
extern  unsigned char boxChars [];      /* Array of box characters      */
extern  unsigned char windowChars [];   /* Array of window characters   */
#endif

extern  char   *envars[];               /* list of recognized env. vars	*/
extern  char   *derNames[];             /* name list of directives      */
extern  unsigned char derTypes[];       /* type list of directives      */
extern  char   *funcNames[];            /* name list of user funcs      */
extern  char    funcTypes[];            /* type list of user funcs      */
extern	KILL	*kbufp;			/* current kill buffer chunk pointer */
extern	KILL	*kbufh;			/* kill buffer header pointer	*/
extern	WINDOW	*swindow;		/* stored window pointer	*/
extern  unsigned char lkbdptr[];        /* Holds last keybd macro data  */
extern  int     lkbdlen;                /* Holds length of last macro   */
extern	unsigned char *kbdptr; 		/* start of current keyboard buf*/
extern	int     kbdlen; 		/* len of current macro         */
extern	int     kbdoff; 		/* current offset of macro      */
extern	int 	kbdrep;			/* number of repetitions	*/
extern  char	emptym[];  	        /* empty literal	        */
extern	char	errorm[];		/* error literal		*/
extern	char	abortm[];		/* abort literal		*/
extern	char	truem[];		/* true literal 		*/
extern	char	falsem[];		/* false litereal		*/
extern  meVARLIST usrVarList;           /* user variables list          */

#if CFENCE
extern  short   statementIndent ;
extern  short   continueIndent ;
extern  short   commentIndent ;
extern  short   braceIndent ;
extern  short   caseIndent ;
extern  short   commentMargin ;
extern  char   *commentCont ;
#endif

/* global buffer names */
extern  char    BsysN[];
extern  char    BcompleteN[];
extern  char    BbindingsN[];
extern  char    BbufflistN[];
extern  char    BicommandN[];
extern  char    BcommandN[];
extern  char    BmainN[];

extern  char *fileIgnore ;
#if FLNEXT
extern  char *flNextFileTemp ;
extern  char *flNextLineTemp ;

extern unsigned char    noNextLine ;
extern char           **nextName ;
extern unsigned char   *nextLineCnt ;
extern char          ***nextLineStr ;

extern  unsigned char fileHookCount ;
extern  char  **fileHookExt ;
extern  char  **fileHookFunc ;
extern  short  *fileHookArg ;
#endif

#if DORCS
extern char *rcsFile ;
extern char *rcsCoStr ;
extern char *rcsCoUStr ;
extern char *rcsCiStr ;
extern char *rcsCiFStr ;
#endif

/* history variables used in mlgetstring */ 
extern  unsigned char numStrHist ;          /* curent no. of hist. strings    */
extern  unsigned char numBuffHist ;         /* curent no. of hist. buff names */
extern  unsigned char numCommHist ;         /* curent no. of hist. comm names */
extern  unsigned char numFileHist ;         /* curent no. of hist. file names */
extern  unsigned char numSrchHist ;         /* curent no. of hist. search strs*/
extern  char **strHist ;                    /* string history list            */
extern  char **buffHist ;                   /* etc.                           */
extern  char **commHist ;
extern  char **fileHist ;
extern  char **srchHist ;
extern  short HistNoFilesLoaded ;         /* Count of no files loaded by hist */

#if HILIGHT

extern  unsigned char   noHilights ;
extern  HILNODEPTR     *hilights ;
extern  unsigned char   noIndents ;
extern  HILNODEPTR     *indents ;

#endif

#if LCLBIND
extern char    useMlBinds;	        /* flag to use ml bindings      */
extern unsigned short mlNoBinds;        /* no. of message line bindings */
extern KEYTAB *mlBinds;                 /* pointer to ml local bindings	*/
#endif

/* uninitialized global external declarations */
extern  char    resultStr[MAXBUF] ;     /* Result string from functions */
extern  char    evalResult[MAXBUF] ;    /* $result variable             */
extern  int     curgoal;                /* Goal for C-P, C-N            */
extern  short   numWindows;             /* Current number of windows    */
extern  WINDOW  *curwp;                 /* Current window               */
extern  BUFFER  *curbp;                 /* Current buffer               */
extern  WINDOW  *wheadp;                /* Head of list of windows      */
extern  BUFFER  *bheadp;                /* Head of list of buffers      */
extern  meABREV *aheadp;                /* Head of list of abrev files  */

extern	struct	KLIST* klhead;		/* Head of klist		*/

/* the character lookup tables */
extern  unsigned char charMaskTbl1[] ;
extern  unsigned char charMaskTbl2[] ;
extern  unsigned char charCaseTbl[] ;
extern  unsigned char charLatinUserTbl[] ;
extern  unsigned char charUserLatinTbl[] ;
extern  unsigned char charMaskFlags[] ;
extern  unsigned char isWordMask ;

/* the following are global variables but not defined in this file */
extern  VVIDEO vvideo;                  /* Virtual video - see display.c */
extern  int    mlfirst;                 /* initial command, set by respawn() */

/* fileio file pointer */
#ifdef _WIN32
extern HANDLE  ffp;
#else
extern FILE   *ffp;
#endif

/* the following are the cursor position and ml variables */
extern int     mwRow ;                  /* Main Windows current row. */
extern int     mwCol ;                  /* Main Windows current column */
extern int     osdCol ;                 /* The osd current column */
extern int     osdRow ;                 /* The osd current row */
#define MLSTATUS_KEEP    0x01
#define MLSTATUS_RESTORE 0x02
#define MLSTATUS_POSML   0x04
#define MLSTATUS_POSOSD  0x08
#define MLSTATUS_CLEAR   0x10
#define MLSTATUS_NINPUT  0x20
#define MLSTATUS_OSDPOS  0x40
extern unsigned char  mlStatus ;
extern int            mlCol ;
extern char          *mlStore ;
extern int            mlStoreCol ;


#ifdef	maindef

/* for MAIN.C */

/* initialized global definitions */
#ifdef _INSENSE_CASE
meDIRLIST  curDirList={0,0} ;
#else
meDIRLIST  curDirList={1,0} ;
#endif
struct osdDIALOG  *osdDialogHd = NULL;  /* Root of the on screen displays */
struct osdDISPLAY *osdDisplayHd = NULL; /* Menu display list */
meREGISTERS *meRegHead=NULL ;           /* The register Head            */
meREGISTERS *meRegCurr=NULL ;           /* The current register set     */
SELHILIGHT selhilight={1,0} ;           /* Selection hilight            */
unsigned short  hilColS=20 ;            /* Hilighting - col chng ary sz */
unsigned char *colSchmTbl = NULL;       /* Highlighting colour table    */
#ifdef _TCAPFONT
unsigned char *fntSchmTbl = NULL;       /* Highlighting font table      */
#endif
#if ABREV
meABREV *globalAbrev = NULL;            /* Global Abreviation file	*/
#endif
int colSchmTblSize = 2;                 /* Size of the colour table     */
HILCOLOR *hilCol;                       /* Hilighting colour change     */
unsigned char *disLineBuff=NULL ;       /* interal display buffer array */
int     disLineSize=512 ;               /* interal display buffer size  */
int     cursorState=0 ;                 /* Current state of cursor      */
FRAMELINE *frameStore = NULL;           /* Frame store line pointers    */
char   *progName=NULL ;                 /* the program name (argv[0])   */
char    orgModeLineStr[]="%s%r%u me (%e) - %l %b (%f) ";
char   *modeLineStr=orgModeLineStr;     /* current modeline format      */
int     autotime = 300 ;                /* auto save time in seconds    */
int     keptVersions = 0 ;              /* No. of kept backup versions  */
char    fillbullet[16]="*)].-";         /* Fill bullet character class  */
short   fillbulletlen = 15;             /* Fill lookahead limit         */
short   fillcol = 78;                   /* Current fill column          */
char    filleos[16]=".!?";              /* Fill E-O-S character class   */
short   filleoslen=1;                   /* Fill E-O-S ' ' insert len    */
char    fillignore[16]=">_@";           /* Fill Ignore character class  */
unsigned short tabsize  = 4; 		/* Virtual Tab size             */
unsigned short tabwidth = 8;        	/* Real TAB size                */
short   matchlen = 2000;                /* Fence matching sleep length  */
char	*searchPath=NULL;           	/* emf search path              */
char	*homedir=NULL;             	/* Home directory               */
char	*curdir=NULL;             	/* current working directory    */
char	*execstr = NULL;		/* pointer to string to execute */
unsigned long delaytime = 500;          /* mouse-time delay time 500ms  */
unsigned long repeattime = 25;          /* mouse-time repeat time 25ms  */
unsigned long idletime = 1000;          /* idle-time delay time 1sec    */
int	execlevel = 0;			/* execution IF level		*/
int	bufHistNo = 1;			/* inc buff hist numbering      */
int     lastCommand = 0 ;               /* The last user executed key   */
int     lastIndex = -1 ;                /* The last user executed comm  */
int     thisCommand = 0 ;               /* The cur. user executed key   */
int     thisIndex = -1 ;                /* The cur. user executed comm  */
int     thisF=0 ;                       /* The cur. user comm args      */
int     thisN=1 ;                       /* The cur. user comm args      */
			
#ifdef _WIN32
HANDLE  ffp;                            /* File pointer, all functions. */
#else
FILE   *ffp;                            /* File pointer, all functions. */
#endif
unsigned short thiskey ;                /* the current key              */
char	hexdigits[] = "0123456789ABCDEF";
unsigned long cursorBlink = 0 ;         /* cursor-blink blink time      */
int     blinkState=1 ;                  /* cursor blink state           */
#if COLOR
int     cursorColor = TTdefFCol ;       /* cursor color                 */
int     osdScheme = 1 ;                 /* Menu line color scheme       */
int     mlScheme   = 0 ;                /* Message line color scheme    */
int     mdLnScheme = 1 ;                /* Mode line color scheme       */
int     sbarScheme = 1 ;                /* Scroll bar color scheme      */
int     globScheme = 0 ;                /* Global color scheme          */
#endif
int     gsbarmode = (WMUP |             /* Has upper end cap            */
                     WMDOWN |           /* Has lower end cap            */
                     WMBOTTM |          /* Has a mode line character    */
                     WMSCROL |          /* Has a box on scrolling shaft */
                     WMRVBOX |          /* Reverse video on box         */
                     WMSPLIT |          /* Has a splitter               */
                     WMVBAR             /* Window has a vertical bar    */
                     );                 /* global scroll bar mode       */
unsigned char boxChars[BCLEN+1] =       /* Set of box characters        */
"|+++++++++-";
unsigned char windowChars[WCLEN+1] =    /* Set of window characters     */
{
    '=',                                /* Mode line current sep */
    '-',                                /* Mode libe inactive sep */
    '#',                                /* Root indicator */
    '*',                                /* Edit indicator */
    '%',                                /* View indicator */ 
    /* Single scroll bar */
    '=',                                /* Buffer split */
    '^',                                /* Scroll bar up */
    ' ',                                /* Scroll bar up shaft */
    ' ',                                /* Scroll box */
    ' ',                                /* Scroll bar down shaft */
    'v',                                /* Scroll bar down */
    '*',                                /* Scroll bar/mode line point */
    /* Double scroll bar */    
    '=','=',                            /* Buffer split */
    '^','^',                            /* Scroll bar up */
    ' ',' ',                            /* Scroll bar up shaft */
    ' ',' ',                            /* Scroll box */
    ' ',' ',                            /* Scroll bar down shaft */
    'v','v',                            /* Scroll bar down */
    '*','*',                            /* Scroll bar/mode line point */
    /* Single horizontal scroll bar */
    '|',                                /* Buffer split */
    '<',                                /* Scroll bar left */
    ' ',                                /* Scroll bar left shaft */
    ' ',                                /* Scroll box */
    ' ',                                /* Scroll bar right shaft */
    '>',                                /* Scroll bar right */
    '*',                                /* Scroll bar/mode line point */
    /* Double horizontal scroll bar */    
    '|','|',                            /* Buffer split */
    '<','<',                            /* Scroll bar left */
    ' ',' ',                            /* Scroll bar left shaft */
    ' ',' ',                            /* Scroll box */
    ' ',' ',                            /* Scroll bar right shaft */
    '>','>',                            /* Scroll bar right */
    '*','*',                            /* Scroll bar/mode line point */
    ' ',                                /* OSD title bar char */
    'x',                                /* OSD Title bar kill char */
    '*',                                /* OSD resize char */
    ' ',                                /* OSD button start char e.g. '['   */
    ' ',                                /* OSD button close char e.g. ']'   */
    0
} ;
unsigned char thisflag;                 /* Flags, this command          */
unsigned char lastflag;                 /* Flags, last command          */
short alarmState=0;                     /* Unix auto-save alarm time    */
long  startTime;                	/* me start time used as offset */
short mouse_X = 0;                      /* mouse X pos at last event    */
short mouse_Y = 0;                      /* mouse X pos at last event    */
short mouse_dX = 0;                     /* mouse delta X last event pos */
short mouse_dY = 0;                     /* mouse delta X last event pos */
unsigned char  mouse_pos=0xff;          /* mouse virtual position       */
#ifdef _WIN32
short mouse_buts = 0;                   /* Number of buttons on mouse   */
#endif
char    fillmode='N';                   /* Justification mode           */
unsigned char scrollFlag = 1 ;          /* horiz/vert scrolling method  */
unsigned char sgarbf = TRUE;            /* TRUE if screen is garbage	*/
unsigned char clexec = FALSE;		/* command line execution flag	*/
unsigned char mcStore = FALSE;		/* storing text to macro flag	*/
signed   char macbug = 0 ;	 	/* macro debuging flag		*/
unsigned char cmdstatus = TRUE;		/* last command status		*/
unsigned char kbdmode=STOP;		/* current keyboard macro mode	*/
unsigned char lastReplace=0;            /* set to non-zero if last was a replace */
unsigned char modeLineFlags=            /* current modeline flags       */
(WFMODE|WFRESIZE|WFMOVEL) ;
unsigned long meSystemCfg=              /* ME system config variable    */
#ifdef _DOS
(meSYSTEM_ANSICOLOR|meSYSTEM_XANSICOLOR|meSYSTEM_MSSYSTEM|meSYSTEM_DRIVES|meSYSTEM_DOSFNAMES|meSYSTEM_TABINDALW|meSYSTEM_ALTMENU|meSYSTEM_ALTPRFX1) ;
#endif
#ifdef _WIN32
(meSYSTEM_RGBCOLOR|meSYSTEM_MSSYSTEM|meSYSTEM_DRIVES|meSYSTEM_DOSFNAMES|meSYSTEM_IPIPES|meSYSTEM_TABINDALW|meSYSTEM_ALTMENU|meSYSTEM_ALTPRFX1|meSYSTEM_CTCHASPC) ;
#endif
#ifdef _UNIX
(meSYSTEM_RGBCOLOR|meSYSTEM_UNIXSYSTEM|meSYSTEM_IPIPES|meSYSTEM_TABINDALW|meSYSTEM_ALTMENU|meSYSTEM_ALTPRFX1) ;
#endif
#ifdef _WIN32
unsigned long meSYSTEM_MASK=            /* ME system mask - dependant on win32 flavour */
(meSYSTEM_TABINDALW|meSYSTEM_ALTMENU|meSYSTEM_ALTPRFX1|meSYSTEM_KEEPUNDO|meSYSTEM_FONTFIX|meSYSTEM_CTCHASPC
#if !defined (_WIN32s)
|meSYSTEM_CLNTSRVR
#endif
) ;
#endif
#if MOUSE
unsigned long meMouseCfg=(3|meMOUSE_ENBLE); /* ME mouse config variable    */
#endif

#if MEUNDO
unsigned long undoContFlag=0;           /* continuation of an undo      */
#endif
#if (defined _DOS) || (defined _WIN32)
unsigned short meUmask=0x020 ;          /* file creation umask          */
#endif
#ifdef _UNIX
unsigned short meUmask ;                /* file creation umask          */
uid_t          meUid ;                  /* current user id              */
gid_t          meGid ;                  /* current group id             */
sigset_t       meSigHoldMask ;          /* signals help when spawning and reading */
#endif

#ifdef _IPIPES
IPIPEBUF *ipipes=NULL ;                 /* list of all the current pipes*/
int       noIpipes=0 ;                  /* count of all the cur pipes   */ 
#endif

LINE *menuLine = NULL;                  /* Menu-poke line */
LINE *lpStore = NULL;			/* line off which to store macro*/
LINE helpStore = 			/* line off which to store macro*/
{ &helpStore, &helpStore, 0 } ;
unsigned short prefixc[ME_PREFIX_NUM+1]=
{ ME_INVALID_KEY,                       /* unused 0th value             */
  ME_SPECIAL|SKEY_esc,           	/* prefix1 = Escape             */
  'X'-'@',		                /* prefix2 = ^X                 */
  'H'-'@',              		/* prefix3 = ^H                 */
  ME_INVALID_KEY, ME_INVALID_KEY,       /* rest unused                  */ 
  ME_INVALID_KEY, ME_INVALID_KEY,
  ME_INVALID_KEY, ME_INVALID_KEY,
  ME_INVALID_KEY, ME_INVALID_KEY,
  ME_INVALID_KEY, ME_INVALID_KEY,
  ME_INVALID_KEY, ME_INVALID_KEY,
  ME_INVALID_KEY
} ;
unsigned short reptc    = 'U'-'@';	/* current universal repeat char*/

KLIST	*klhead	  = NULL;	/* klist header pointer		   */
WINDOW	*swindow  = NULL;	/* stored window pointer	   */
unsigned char lkbdptr[NKBDM];   /* Holds last keybd macro data     */
int     lkbdlen=0;              /* Holds length of last macro      */
unsigned char *kbdptr=NULL; 	/* start of current keyboard buf   */
int     kbdlen=0; 		/* len of current macro            */
int     kbdoff=0; 		/* current offset of macro         */
int 	kbdrep=0;		/* number of repetitions 	   */
char	emptym[]  = "";  	/* empty literal		   */
char	errorm[]  = "ERROR";	/* error literal		   */
char	abortm[]  = "ABORT";	/* abort literal		   */
char	truem[]   = "1";	/* true literal 		   */
char	falsem[]  = "0";	/* false litereal	           */
meVARLIST usrVarList={NULL,0} ; /* user variables list             */


#if CFENCE
short   statementIndent = 4 ;
short   continueIndent  = 10 ;
short   commentIndent   = 1 ;
short   braceIndent     = -4 ;
short   caseIndent      = -4 ;
short   commentMargin   = -1 ;
char   *commentCont     = NULL ;
#endif

/* global buffer names */
char    BsysN[] = { 0x7f,0x7f,0x0 } ;
char    BcompleteN[] = "*complete*" ;
char    BicommandN[] = "*icommand*";
char    BcommandN[] = "*command*";
char    BmainN[] = "*scratch*";

char *fileIgnore=NULL ;

#if FLNEXT
char *flNextFileTemp=NULL ;
char *flNextLineTemp=NULL ;

unsigned char    noNextLine=0 ;
char           **nextName=NULL ;
unsigned char   *nextLineCnt=NULL ;
char          ***nextLineStr=NULL ;

unsigned char fileHookCount=0 ;
char  **fileHookExt=NULL ;
char  **fileHookFunc=NULL ;
short  *fileHookArg=NULL ;
#endif                           

#if DORCS
char *rcsFile=NULL ;
char *rcsCoStr=NULL ;
char *rcsCoUStr=NULL ;
char *rcsCiStr=NULL ;
char *rcsCiFStr=NULL ;
#endif

/* history variables used in mlgetstring */ 
unsigned char numStrHist = 0 ;       /* curent no. of hist. strings    */
unsigned char numBuffHist = 0 ;      /* curent no. of hist. buff names */
unsigned char numCommHist = 0 ;      /* curent no. of hist. comm names */
unsigned char numFileHist = 0 ;      /* curent no. of hist. file names */
unsigned char numSrchHist = 0 ;      /* curent no. of hist. search strs*/
char **strHist ;                     /* string history list            */
char **buffHist ;                    /* etc.                           */
char **commHist ;
char **fileHist ;
char **srchHist ;
short HistNoFilesLoaded = 0 ;        /* Count of no files loaded by hist */

#if HILIGHT

unsigned char   noHilights=0 ;
HILNODEPTR     *hilights=NULL ;
unsigned char   noIndents=0 ;
HILNODEPTR     *indents=NULL ;

#endif

#if LCLBIND
char    useMlBinds=0;	        /* flag to use ml bindings      */
unsigned short mlNoBinds=0;     /* no. of message line bindings */
KEYTAB *mlBinds=NULL;	        /* pointer to ml local bindings	*/
#endif

int     curgoal;                /* Goal for C-P, C-N            */
short   numWindows;             /* Number of windows            */
WINDOW  *curwp;                 /* Current window               */
BUFFER  *curbp;                 /* Current buffer               */
WINDOW  *wheadp;                /* Head of list of windows      */
BUFFER  *bheadp;                /* Head of list of buffers      */
meABREV *aheadp=NULL;           /* Head of list of abrev files  */

short   keyTableSize;           /* The current size of the key table */
char    resultStr [MAXBUF];     /* Result string from commands  */

/* the following are the cursor position and ml variables */
int mwRow =0 ;                  /* Main Windows current row. */
int mwCol =0 ;                  /* Main Windows current column */
int osdCol=0 ;                  /* The osd current column */
int osdRow=0 ;                  /* The osd current row */

int mlCol=0 ;                   /* ml current column */
int mlStoreCol=0 ;              /* ml Store column */
char          *mlStore;         /* stored message line. */
unsigned char  mlStatus=0 ;     /* ml status
                                 * 0=not using it,
                                 * 1=using it.
                                 * 2=using it & its been broken so
                                 * next time mlerease is used, it will
                                 * restore */
#ifdef _CLIPBRD
unsigned char clipState=0;      /* clipboard status flag        */
#endif
#endif

