/* -*- C -*- ****************************************************************
 *
 *  			Copyright 1999 Jasspa
 *
 *  System        : MicroEmacs Jasspa Distribution
 *  Object Name   : $RCSfile$
 *  Revision      : $Revision$
 *  Date          : $Date$
 *  Author        : $Author$
 *  Created By    : Jon Green
 *  Created       : Mon Mar 9 23:54:24 1998
 *  Last Modified : <020699.1622>
 *
 *  Description	
 *       Printer definitions
 *  Notes
 *
 *  History
 *	
 *  $Log$
 *
 ****************************************************************************
 *
 * Copyright (C) 1998 - 1999, JASSPA 
 *
 * The MicroEmacs Jasspa distribution can be copied and distributed freely for
 * any non-commercial purposes. The MicroEmacs Jasspa Distribution can only be
 * incorporated into commercial software with the expressed permission of
 * JASSPA.
 *  
 ****************************************************************************/

#ifndef __EPRINT_H
#define __EPRINT_H

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/* Local printer types include
 * mePD_INT   0x01     Integer data
 * mePD_STR   0x00     String data
 * mePD_WIN   0x02     Autosave items for windows into Microemacs registry. 
 */
#define mePD_STR   0x00                   /* String data */
#define mePD_INT   0x01                   /* Integer data */
#define mePD_WIN   0x02                   /* Windows autosave */

/* Page sizes - Determine user requirements for sizing */
#define PAGSIZ_DONTCARE          0      /* Do not care what size is */
#define PAGSIZ_EXACT             1      /* Require exact page size (if possible) */
#define PAGSIZ_MIN               2      /* This is a minimum page size */

/* Printer font definitions. */
#define INUMFONTS 4                     /* Integer number of fonts */
#define P2_NUMFONTS (1<<INUMFONTS)      /* Number of fonts ^ 2 */
/* Font bit positions */
#define PFONT_BOLD               0x01   /* Bold font */
#define PFONT_ITALIC             0x02   /* Italic font */
#define PFONT_UNDER              0x04   /* Underline font */
#define PFONT_REV                0x08   /* Reverse font */
#define PFONT_MAX                0x10   /* Maximum mask for fonts */
#define PFONT_OEM                0x10   /* *Special* Windows OEM font */

#define PFLAG_ENBLHEADER         0x10   /* Enable the header */
#define PFLAG_ENBLFOOTER         0x20   /* Enable the footer */
#define PFLAG_ENBLLINENO         0x40   /* Enable line nos */
#define PFLAG_ENBLTRUNCC         0x80   /* Enable truncated line '\' char */

/* Define the destinations */
#define PDEST_BUFFER             0x00   /* To Buffer only */
#define PDEST_INTERNAL           0x01   /* Internal queue */
#define PDEST_FILE               0x02   /* To File only */
#define PDEST_COMLINE            0x03   /* To File & Command line */

/*
 * For the windows dialogue define the timer constants used to update the
 * dialogue. 
 */
#ifdef _WIN32
#define PRINT_TIMER_ID           10     /* Timer handle identity */
#define PRINT_TIMER_RESPONSE    100     /* Respond within 100 milliseconds */
#endif

/*
 * PDESC
 * Print descriptor.
 */
typedef union
{
    long l;                             /* Integer component */
    char *p;                            /* Character pointer */
} LPU;

enum
{
#define DEFPRINT(s,t,v) v,
#include "eprint.def"
    PRINT_MAX
#undef DEFPRINT
};

typedef struct
{
    LPU param [PRINT_MAX];              /* Parameter */
    struct tm *ptime;                   /* Print time */
    int pDestination;                   /* Output destination */
    int pNoLines;                       /* Number of lines */
    int pPageNo;                        /* Page number */
    int pLineNo;                        /* Line number */
    int pLinesPerPage;                  /* Number of lines per page */
    long pLineNumDigits;                /* Number of line number digits */
    char *pDeviceMajor;                 /* Major device name */
    char *pDeviceMinor;                 /* Minor device name */
    char **filter;                      /* Character filter table */
} PRINTER;

extern char *printNames [];
extern char printTypes[];
extern PRINTER printer;

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif
#endif /* __EPRINT_H */
