##############################################################################
#
#			MicroEmacs Jasspa Distribution 1998.
#
#  System        : MicroEmacs
#  Module        :
#  Object Name   : $RCSfile$
#  Revision      : $Revision$
#  Date          : $Date$
#  Author        : $Author$
#  Created       : Sat Jan 24 00:01:40 1998
#
#  Last Modified : <990617.0902>
#
#  Description	 : Make file for Linux - Slackware '96 V2.0.0
#
#  Notes
#
#  History
#
#  $Log$
#
##############################################################################
#
# Installation Directory
INSTDIR	      = /usr/local/bin
INSTPROGFLAGS = -s -u root -g root -n $(INSTDIR)
#
# CFLAGS - pick optimised or debugged.
CTYPE         = $(COPTIMISE)
#CTYPE         = $(CDEBUG)
#
# Strip command - not to be performed on debug builds
STRIP         = $(STRIPOPTIMISE)
#STRIP         = $(STRIPDEBUG)
#
# Local Definitions
RM            = rm -f
CC            = cc
LD            = $(CC)
STRIPOPTIMISE =	strip
STRIPDEBUG    =	echo Building debug - not stripping
CDEBUG        =	+z -g -Aa -Ae -z
COPTIMISE     =	+z -O -Aa -Ae -DNDEBUG=1 -z
CDEFS         = -D_JASSPA_ME -D_HPUX -D_HPUX9 -D_UNIX -I/usr/include/X11R5 -I.
CFLAGS        = $(CTYPE) $(CDEFS)
LIBS          = -lX11 -ltermcap -ldld -lV3
LDFLAGS       = -L/usr/lib/X11R5
INSTALL       =	install
#
#
#  Define the Files.
#
HEADERS = ebind.h edef.h eextrn.h efunc.h esearch.h estruct.h evar.h \
	  evers.h eterm.h ebind.def efunc.def evar.def emain.h eprint.h
PLTHDR  = 

STDSRC	= abbrev.c basic.c bind.c buffer.c crypt.c dirlist.c display.c \
	  eval.c exec.c file.c fileio.c hilight.c history.c input.c \
	  isearch.c key.c line.c macro.c main.c narrow.c next.c osd.c \
	  print.c registry.c random.c region.c search.c spawn.c spell.c \
	  tag.c termio.c time.c undo.c window.c word.c regex.c
PLTSRC  = unixterm.c

STDOBJ	= $(STDSRC:.c=.o)	
PLTOBJ  = $(PLTSRC:.c=.o)
OBJ	= $(STDOBJ) $(PLTOBJ)
#
# Dependancies
#
all: me

install: me
	$(INSTALL) $(INSTPROGFLAGS) me $(INSTDIR)
	@echo "install done"

clean:
	$(RM) me *.o core lib*.a print.ps

spotless: clean
	$(RM) tags *~

me:	$(OBJ)
	$(RM) $@
	$(LD) $(LDFLAGS) -o $@ $(OBJ) $(LIBS)
	$(STRIP) $@

$(STDOBJ):: $(HEADERS)
$(PLTOBJ):: $(HEADERS) $(PLTHDR)


