/****************************************************************************
 *
 *  			Copyright 1995 - 1999 Jasspa
 *
 *  System        : MicroEmacs Jasspa Distribution
 *  Object Name   : $RCSfile$
 *  Revision      : $Revision$
 *  Date          : $Date$
 *  Author        : $Author$
 *  Created By    : Steve Philips
 *  Created       : 1995 Sometime
 *  Last Modified : <160699.0735>
 *
 *  Description	
 *      Undo changes
 *  Notes
 *
 *  History
 *	
 *  $Log$
 *
 ****************************************************************************
 *
 * Copyright (C) 1995 - 1999, JASSPA 
 *
 * The MicroEmacs Jasspa distribution can be copied and distributed freely for
 * any non-commercial purposes. The MicroEmacs Jasspa Distribution can only be
 * incorporated into commercial software with the expressed permission of
 * JASSPA.
 *  
 ****************************************************************************/

/*---	Include defintions */

#define	__UNDOC	1			/* Define the filename */

/*---	Include files */

#include "emain.h"

#if MEUNDO

UNDOND *
meUndoCreateNode(size_t size)
{
    UNDOND *nn ;
    
    if((nn = meMalloc(size)) != NULL)
    {
        nn->type = 0 ;
        nn->next = curbp->fUndo ;
        curbp->fUndo = nn ;
        nn->udata.dotp = curwp->line_no ;
        nn->doto  = curwp->w_doto ;
        nn->str[0] = '\0' ;
        if(curbp->undoContFlag == undoContFlag)
            nn->type |= MEUNDO_CONT ;
        else
            curbp->undoContFlag = undoContFlag ;
    }
    return nn ;
}

    
void
meUndoAddInsChar(void)
{
    if(meModeTest(curbp->b_mode,MDUNDO))
    {
        unsigned char type=MEUNDO_SING|MEUNDO_MINS ;
        UNDOND *nn ;
        
        if(curbp->undoContFlag == undoContFlag)
            type |= MEUNDO_CONT ;
            
        if(((nn = curbp->fUndo) != NULL) && (nn->type == type) &&
           (nn->udata.dotp == curwp->line_no) &&
           (nn->doto == curwp->w_doto-1))
        {
            nn->doto++ ;
            nn->count++ ;
            curbp->undoContFlag = undoContFlag ;
        }
        else if((nn = meUndoCreateNode(sizeof(UNDOND))) != NULL)
        {
            nn->type |= MEUNDO_SING|MEUNDO_MINS ;
            nn->count = 1 ;
        }
    }
}

void
meUndoAddDelChar(void)
{
    if(meModeTest(curbp->b_mode,MDUNDO))
    {
        unsigned char type=MEUNDO_SING|MEUNDO_MDEL ;
        UNDOND *nn ;
        char    cc ;
        
        if((cc = curwp->w_dotp->l_text[curwp->w_doto]) == '\0')
        {
            if((curwp->line_no == curbp->elineno-1) && (curwp->w_doto))
                /* This is trying to just remove the end line when the line
                 * before is not empty, this will fail so don't store it
                 */
                return ;
            cc = meNLCHAR ;
        }
        if(curbp->undoContFlag == undoContFlag)
            type |= MEUNDO_CONT ;
        
        nn = curbp->fUndo ;
        if((nn != NULL) && ((nn->type & ~MEUNDO_REVS) == type) &&
           (nn->udata.dotp == curwp->line_no))
        {
            if(!(nn->type & MEUNDO_REVS) && (nn->doto == curwp->w_doto))
                ;
            else if(((nn->doto-nn->count) == curwp->w_doto) &&
                    (((nn->type & MEUNDO_REVS) != 0) || (nn->count == 1)))
                nn->type |= MEUNDO_REVS ;
            else
                goto meUndoAddDelCharNew ;
            if(!(nn->count & 0x0f) &&
               ((nn = meRealloc(nn,sizeof(UNDOND)+nn->count+18)) == NULL))
                return ;
            curbp->fUndo = nn ;
            nn->str[nn->count++] = cc ;
            nn->str[nn->count]   = '\0' ;
            curbp->undoContFlag = undoContFlag ;
        }
        else
        {
meUndoAddDelCharNew:
            if((nn = meUndoCreateNode(sizeof(UNDOND)+18)) != NULL)
            {
                nn->type |= MEUNDO_MDEL|MEUNDO_SING ;
                nn->count = 1 ;
                nn->str[0] = cc ;
                nn->str[1] = '\0' ;
            }
        }
    }
}

void
meUndoAddRepChar(void)
{
    if(meModeTest(curbp->b_mode,MDUNDO))
    {
        unsigned char type=MEUNDO_SING|MEUNDO_MINS|MEUNDO_MDEL ;
        UNDOND *nn ;
        char    cc ;
        
        if(curbp->undoContFlag == undoContFlag)
            type |= MEUNDO_CONT ;
        if((cc = curwp->w_dotp->l_text[curwp->w_doto]) == '\0')
            cc = meNLCHAR ;
        nn = curbp->fUndo ;
        if((nn != NULL) && (nn->type == type) &&
           (nn->udata.dotp == curwp->line_no) &&
           (nn->doto == curwp->w_doto-1))
        {
            if(!(nn->count & 0x0f) &&
               ((nn = meRealloc(nn,sizeof(UNDOND)+nn->count+18)) == NULL))
                return ;
            curbp->fUndo = nn ;
            nn->doto++ ;
            nn->str[nn->count++] = cc ;
            nn->str[nn->count]   = '\0' ;
            curbp->undoContFlag = undoContFlag ;
        }
        else if((nn = meUndoCreateNode(sizeof(UNDOND)+18)) != NULL)
        {
            nn->type |= MEUNDO_MDEL|MEUNDO_SING|MEUNDO_MINS ;
            nn->count = 1 ;
            nn->str[0] = cc ;
            nn->str[1] = '\0' ;
        }
    }
}

void
meUndoAddInsChars(int numChars)
{
    UNDOND *nn ;
    
    if(meModeTest(curbp->b_mode,MDUNDO) &&
       ((nn = meUndoCreateNode(sizeof(UNDOND))) != NULL))
    {
        nn->type |= MEUNDO_MINS|MEUNDO_REVS ;
        nn->count = numChars ;
    }
}

void
meUndoAddDelChars(int numChars)
{
    UNDOND *nn ;
    
    if(numChars < 0)
        numChars = 0 ;
    if(meModeTest(curbp->b_mode,MDUNDO) &&
       ((nn = meUndoCreateNode(sizeof(UNDOND)+numChars)) != NULL))
    {
        LINE   *ll = curwp->w_dotp ;
        int     len ;
        char   *dd=nn->str, *ss=(char *) ll->l_text+curwp->w_doto ;
        
        nn->type |= MEUNDO_MDEL ;
        if((len = llength(ll) - curwp->w_doto) < numChars)
        {
            for(;;)
            {
                numChars-=len+1 ;
                for(; len ; len--)
                    *dd++ = *ss++ ;
                ll = lforw(ll) ;
                ss = (char *) ll->l_text ;
                /* A bit of a bodge here to cope with the bogus last line
                 * If the last but 1 line's '\n' is about to be removed
                 * don't actually store the '\n' as this is automatically
                 * added by the system
                 */
                if((numChars == 0) && (ll == curbp->b_linep))
                    break ;
                *dd++ = meNLCHAR ;
                if(numChars <= (len=llength(ll)))
                    break ;
            }
        }
        for(; numChars ; numChars--)
            *dd++ = *ss++ ;
        *dd = '\0' ;
    }
}

void
meUndoAddReplaceBgn(LINE *elinep, unsigned short elineo)
{
    if(meModeTest(curbp->b_mode,MDUNDO))
    {
        UNDOND *nn ;
        int     len ;
        
        if(elinep == curbp->b_linep)
        {
            elinep = lback(elinep) ;
            elineo = llength(elinep) ;
        }
        if(elinep == curwp->w_dotp)
            len = elineo - curwp->w_doto ;
        else
        {
            LINE *ll = curwp->w_dotp ;
            len = llength(ll) - curwp->w_doto + elineo+1 ;
            while((ll = lforw(ll)) != elinep)
                len += llength(ll)+1 ;
        }
        if((nn = meUndoCreateNode(sizeof(UNDOND)+len)) != NULL)
        {
            LINE *ll = curwp->w_dotp ;
            char *dd=nn->str, *ss=(char *) ll->l_text+curwp->w_doto ;
            
            nn->type |= MEUNDO_MDEL ;
            if(elinep == curwp->w_dotp)
            {
                for(; len ; len--)
                    *dd++ = *ss++ ;
            }
            else
            {
                len = llength(ll) - curwp->w_doto ;
                for(; len ; len--)
                    *dd++ = *ss++ ;
                *dd++ = meNLCHAR ;
                while((ll = lforw(ll)) != elinep)
                {
                    len = llength(ll) ;
                    ss = (char *) ll->l_text ;
                    for(; len ; len--)
                        *dd++ = *ss++ ;
                    *dd++ = meNLCHAR ;
                }
                ss = (char *) ll->l_text ;
                for(; elineo ; elineo--)
                    *dd++ = *ss++ ;
            }
            *dd = '\0' ;
        }
    }
}

void
meUndoAddReplaceEnd(int numChars)
{
    if(meModeTest(curbp->b_mode,MDUNDO))
    {
        curbp->fUndo->count = numChars ;
        curbp->fUndo->type |= MEUNDO_MINS ;
    }
}

void
meUndoAddReplace(char *dstr, int count)
{
    if(meModeTest(curbp->b_mode,MDUNDO))
    {
        UNDOCOORD *co ;
        UNDOND    *nn ;
        int        doto, contFlag ;
        
        contFlag = (curbp->undoContFlag == undoContFlag) ;
        
        nn = curbp->fUndo ;
        if((nn == NULL) ||
           !(nn->type & MEUNDO_REPL) ||
           (nn->count != count) ||
           (nn->doto == 0xffff) ||
           strcmp(nn->str,dstr))
        {
            char *dd ;
            if((nn = meUndoCreateNode(sizeof(UNDOND)+strlen(dstr))) == NULL)
                return ;
            nn->type |= MEUNDO_MDEL|MEUNDO_MINS|MEUNDO_REPL|MEUNDO_REVS ;
            nn->udata.pos = NULL ;
            nn->doto = 0 ;
            nn->count = count ;
            dd = nn->str ;
            while((*dd++ = *dstr++))
                ;
        }
        /* replace is the same as last time */
        if(!(nn->doto & 0x0f) &&
           ((nn->udata.pos = meRealloc(nn->udata.pos,sizeof(UNDOCOORD)*
                                       (nn->doto+16))) == NULL))
            return ;
        co = nn->udata.pos ;
        doto = curwp->w_doto ;
        if(contFlag)
            doto = 0 - doto ;
        co[nn->doto][0]   = curwp->line_no ;
        co[nn->doto++][1] = doto ;
        curbp->undoContFlag = undoContFlag ;
    }
}

#if NARROW
/* NOTE: Narrow undos are only added if there is already an
 * undo. This is so the state of the buffer will be correct
 * for the previous undo
 */
void
meUndoAddNarrow(long sln, int name)
{
    UNDOND *nn ;
    
    if((curbp->fUndo != NULL) &&
       ((nn = meUndoCreateNode(sizeof(UNDOND))) != NULL))
    {
        nn->type |= MEUNDO_NRRW ;
        nn->udata.dotp = sln ;
        nn->doto = name ;
        nn->count = -1 ;
    }
}
void
meUndoAddUnnarrow(long sln, long eln, int name)
{
    UNDOND *nn ;
    
    if((curbp->fUndo != NULL) &&
       ((nn = meUndoCreateNode(sizeof(UNDOND))) != NULL))
    {
        nn->type |= MEUNDO_NRRW ;
        nn->udata.dotp = sln ;
        nn->doto = name ;
        nn->count = eln ;
    }
}
#endif

void
meUndoRemove(BUFFER *bp)
{
    UNDOND *nn ;
    
    while((nn=bp->fUndo) != NULL)
    {
        bp->fUndo = nn->next ;
        if(nn->type & MEUNDO_REPL)
            free(nn->udata.pos) ;
        free(nn) ;
    }
}

int
meUndo(int f, int n)
{
    if(n < -1)
    {
#ifndef NDEBUG
        if(n == -4)
        {
            UNDOND *nn ;
            nn=curbp->fUndo ;
            while(nn != NULL)
            {
                printf("Undo %x %x %ld (%ld,%d) [%s]\n",nn->type,(int) nn->next,nn->count,
                       nn->udata.dotp,nn->doto,nn->str) ;
                if(nn->type & MEUNDO_REPL)
                {
                    int ii ;
                    for(ii=0 ; ii<nn->doto ; ii++)
                        printf("(%d,%d) ",nn->udata.pos[ii][0],nn->udata.pos[ii][1]) ;
                    printf("\n") ;
                }
                nn = nn->next ;
            }
        }
        else
#endif
            undoContFlag++ ;
    }
    else if(!meModeTest(curbp->b_mode,MDUNDO))
        return ctrlg(FALSE,1) ;
    else if(n < 0)
        meUndoRemove(curbp) ;
    else
    {
        static UNDOND *cun ;
        static long ccount ;
        static unsigned short cdoto ;
    
        if((lastflag != CFUNDO) && ((cun = curbp->fUndo) != NULL))
        {
            cdoto = cun->doto ;
            ccount = cun->count ;
        }
        for(;;)
        {
            int count, cont ;
            if((cun == NULL) || ((n <= 0) && !meModeTest(curbp->b_mode,MDEDIT)))
                break ;
            if(bchange() != TRUE)               /* Check we can change the buffer */
                return ABORT ;
            cont=0 ;
#if NARROW
            if(cun->type & MEUNDO_NRRW)
            {
                if(ccount < 0)
                {
                    meNARROW *nrrw ;
                    nrrw = curbp->narrow ;
                    while(nrrw->name != cdoto)
                        nrrw = nrrw->next ;
                    gotoLine(TRUE,cun->udata.dotp+1) ;
                    curbp->b_dotp = curwp->w_dotp ;
                    curbp->line_no = curwp->line_no ;
                    curbp->b_doto = 0 ;
                    removeNarrow(curbp,nrrw,1) ;
                }
                else
                {
                    LINE *slp ;
                    gotoLine(TRUE,cun->udata.dotp+1) ;
                    slp = curwp->w_dotp ;
                    gotoLine(TRUE,ccount+1) ;
                    createNarrow(curbp,slp,curwp->w_dotp,cun->udata.dotp,ccount,cdoto) ;
                }
                if(cun->type & MEUNDO_CONT)
                    cont=1 ;
                goto meUndoNext ;
            }
#endif
            if(cun->type & MEUNDO_REPL)
            {
                gotoLine(TRUE,cun->udata.pos[cdoto-1][0]+1) ;
                count = cun->udata.pos[cdoto-1][1] ;
                if(count < 0)
                {
                    cont = 1 ;
                    count = 0 - count ;
                }
                curwp->w_doto = count ;
            }
            else
            {
                if(cun->type & MEUNDO_CONT)
                    cont = 1 ;
                if(cun->type & MEUNDO_FRST)
                {
                    if(!(cun->type & MEUNDO_MDEL))
                    {
                        autowriteremove(curbp) ;
                        meModeClear(curbp->b_mode,MDEDIT) ;
                        curwp->w_flag |= WFMODE ;
                    }
                    goto meUndoNext ;
                }
                gotoLine(TRUE,cun->udata.dotp+1) ;
                curwp->w_doto = cdoto ;
            }
            if(cun->type & MEUNDO_SING)
            {
                ccount-- ;
                count = 1 ;
            }
            else
                count = ccount ;
            if(cun->type & MEUNDO_REVS)
                WbackChar(curwp,ccount) ;
            if(cun->type & MEUNDO_MINS)
                ldelete(count,2) ;
            if(cun->type & MEUNDO_MDEL)
            {
                char *ss, cc ;
                ss = cun->str ;
                if(cun->type & MEUNDO_SING)
                {
                    meUndoAddInsChar() ;
                    ss += ccount ;
                }
                count = 0 ;
                while((cc=*ss++) != '\0')
                {
                    if(cc == meNLCHAR)
                        lnewline();
                    else
                        linsert(1, cc);
                    if(cun->type & MEUNDO_SING)
                        break ;
                    count++ ;
                }
                if(count)
                    meUndoAddInsChars(count) ;
            }
            if((cun->type & MEUNDO_SING) && (ccount > 0))
            {
                if(cun->type & MEUNDO_MINS)
                    cdoto-- ;
            }
            else if(cun->type & MEUNDO_REPL)
            {
                cdoto-- ;
                if(!cdoto)
                    goto meUndoNext ;
            }
            else
            {
meUndoNext:
                if((cun = cun->next) != NULL)
                {
                    cdoto = cun->doto ;
                    ccount = cun->count ;
                }
            }
            if(!cont && (--n == 0))
                break ;
        }
        thisflag = CFUNDO ;
    }
    return TRUE ;
}
#endif

