/*
 *      SCCS:           %W%             %G%             %U%
 *
 *      Last Modified : <020699.1622>
 *
 *      tcap:   Unix V5, V7 and BS4.2 Termcap video driver
 *              for MicroEMACS
 ****************************************************************************
 * 
 * Modifications to the original file by Jasspa. 
 * 
 * Copyright (C) 1988 - 1999, JASSPA 
 * The MicroEmacs Jasspa distribution can be copied and distributed freely for
 * any non-commercial purposes. The MicroEmacs Jasspa Distribution can only be
 * incorporated into commercial software with the expressed permission of
 * JASSPA.
 * 
 ****************************************************************************/
 

#include "emain.h"
#include "efunc.h"

#include <errno.h>
#include <fcntl.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/ioctl.h>

int meSigLevel=0 ;

#define DEFFONT(fntenum,fntname,fntstr,fntbcol) fntenum,
enum {
#include "efont.def"
FNTNUMFONTS
};
#undef DEFFONT

#define DEFFONT(fntenum,fntname,fntstr,fntbcol) fntname,
char   *fontName[] = {                  /* name of fonts                */
#include "efont.def"
};
#undef DEFFONT

#define DEFFONT(fntenum,fntname,fntstr,fntbcol) fntstr,
char   *fontStr[] = {                   /* termcap lookup strings       */
#include "efont.def"
};
#undef DEFFONT

#define DEFFONT(fntenum,fntname,fntstr,fntbcol) fntbcol,
unsigned char fontBcol[] = {           /* font background color effect  */
#include "efont.def"
};
#undef DEFFONT

char *fontComm[FNTNUMFONTS] ;           /* termcap command strings      */
unsigned long fontMask[FNTNUMFONTS*HCTNUM]={0} ;

#ifdef _MEVMS
#include        <stsdef.h>
#include        <ssdef.h>
#include        <descrip.h>
#include        <iodef.h>
#include        <ttdef.h>
#include        <tt2def.h>

#define NIBUF   128                     /* Input buffer size            */
#define NOBUF   1024                    /* MM says bug buffers win!     */
#define EFN     0                       /* Event flag                   */

char    obuf[NOBUF];                    /* Output buffer                */
int     nobuf;                  /* # of bytes in above    */
char    ibuf[NIBUF];                    /* Input buffer          */
int     nibuf;                  /* # of bytes in above  */
int     ibufi;                  /* Read index                   */
int     oldmode[3];                     /* Old TTY mode bits            */
int     newmode[3];                     /* New TTY mode bits            */
short   iochan;                  /* TTY I/O channel             */
#endif


#ifdef _USG                     /* System V */
/* We need this stuff to do the pipes properly. */
#ifdef _TERMIOS
#include <termios.h>
struct  termios otermio;        /* original terminal characteristics */
struct  termios ntermio;        /* charactoristics to use inside */
#else
#include <termio.h>
struct  termio  otermio;        /* original terminal characteristics */
struct  termio  ntermio;        /* charactoristics to use inside */
#endif
#endif

#if (defined _V7) || (defined _BSD)
#include        <sgtty.h>        /* for stty/gtty functions */
struct  sgttyb  ostate;          /* saved tty state */
struct  sgttyb  nstate;          /* values for editor mode */
struct tchars   otchars;        /* Saved terminal special character set */
struct tchars   ntchars = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff };
                                /* A lot of nothing */
#ifdef _BSD
extern  int rtfrmshell();       /* return from suspended shell */
#define TBUFSIZ 128
char tobuf[TBUFSIZ];            /* terminal output buffer */
struct  ltchars oltchars;
struct  ltchars nltchars;

static struct sgttyb cursgtty;          /* Current modes                */
static struct sgttyb oldsgtty;          /* Original modes               */
static struct tchars oldtchars;         /* Current tchars               */
static struct ltchars oldlchars;        /* Current ltchars              */
static char blank[6] =                  /* Blank out character set      */
        { -1, -1, -1, -1, -1, -1 };
#endif /* _BSD */
#endif /* _V7 || _BSD */

#define putpad(s)  tputs(s, 1, putchar)

#define TCAPSLEN 512
unsigned  short  TTmrow=0, TTnrow=49, TTmcol=0, TTncol=80 ;
unsigned  short  TTnewWid, TTnewHig  ;
unsigned  short  TTmargin=8  ;
unsigned  short  TTscrsiz=64 ;
static    char   tcapbuf[TCAPSLEN];
char *CM, *CL, *SE ;
/* , *VI, *VE ; */
#if COLOR
unsigned char  noColors=0 ;
unsigned long *colTable=NULL ;

#define tcapNumColors 16
static unsigned char tcapColors[tcapNumColors*3] =
{
    0,0,0,    200,0,0, 0,200,0, 200,200,0, 0,0,200, 200,0,200, 0,200,200, 200,200,200,
    75,75,75, 255,0,0, 0,255,0, 255,255,0, 0,0,255, 255,0,255, 0,255,255, 255,255,255,
} ;

short Dforgc=7, Dbacgc=0 ;
char RCOLSTR[] = { 27, 91, 48,     109, 0 } ;
char FCOLSTR[] = { 27, 91, 51, 65, 109, 0 } ;
char BCOLSTR[] = { 27, 91, 52, 65, 109, 0 } ;
char LOCKSTR[] = { /* 27, 91, 61, 54, 104, */
                   27, 91, 63, 55, 108, 0 } ;
char UNLKSTR[] = { /* 27, 91, 61, 54, 108, */
                   27, 91, 63, 55, 104, 0 } ;
#endif

extern int      tgetnum(char *);
extern int      tgetent(char *,char *);
extern char *   tgetstr(char *,char **);
extern int      tputs(char *,int, int (*)(int));

#include	"eskeys.h"

#define	DEFSKEY(s,i,d,t) i,

static char *tcapSpecKeyStrs[]=
{
#include	"eskeys.def"
};
#undef	DEFSKEY

#define	DEFSKEY(s,i,d,t) (unsigned char *) d,

static unsigned char *tcapSpecKeyDefs[]=
{
#include	"eskeys.def"
};
#undef	DEFSKEY


#ifdef _XTERM

#include <X11/Xatom.h>
#include <X11/cursorfont.h>

/* Setup the xterm variables and things */
/* Set of macros to interchange pixel and character spaces coordinates */
#define rowToClient(y) (fdepth*(y))     /* Convert row char => pixel */
#define colToClient(x) (fwidth*(x))     /* Convert column char => pixel */
#define clientToRow(y) ((y)/fdepth)     /* Convert row pixel => char */
#define clientToCol(x) ((x)/fwidth)     /* Convert column pixel => char */

static int disableResize = 0;           /* Flag to disable screen resize */

Display *xdisplay ;
GC       xgc ;
Window   xwindow ;
Colormap xcmap ;
int      xscreen ;
XSizeHints sizeHints ;
int fwidth ;                            /* Font width in pixels */
int fdepth ;                            /* Font depth in pixels */
int fhwidth ;                           /* Font half width in pixels */
int fhdepth ;                           /* Font half depth in pixels */
int fadepth ;                           /* Font up-arrow depth in pixels */
int ascent ;
int meStdin ;
#define meATOM_WM_DELETE_WINDOW 0
#define meATOM_WM_SAVE_YOURSELF 1
#define meATOM_WM_PROTOCOLS     2
#define meATOM_COPY_TEXT        3
#define meATOM_TARGETS          4
#define meATOM_INCR             5
#define meATOM_MULTIPLE         6
static Atom meAtoms[7]={0};
char *meName="MicroEmacs" ;

#define iconWidth  32
#define iconHeight 32
static unsigned char iconBits[] = {
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xf0, 0x00, 0xde, 0x3f, 0xf0, 0x00, 0xde, 0x3f,
    0xf0, 0x01, 0xdf, 0x3f, 0xf0, 0x01, 0xdf, 0x3f,
    0xf8, 0x83, 0xff, 0x0a, 0xf4, 0x83, 0x5f, 0x05,
    0xf8, 0xc7, 0xff, 0x0a, 0xf4, 0xc7, 0x5f, 0x05,
    0xf8, 0xef, 0x7f, 0x00, 0xf4, 0xef, 0x5f, 0x00, 
    0xf8, 0xff, 0xff, 0x0f, 0xf4, 0xfe, 0xde, 0x0f,
    0xf8, 0xfe, 0xfe, 0x0f, 0xf4, 0x7c, 0xde, 0x0f,
    0xf8, 0x7d, 0xff, 0x02, 0xf4, 0xba, 0x5e, 0x01,
    0xf8, 0x39, 0xff, 0x02, 0xf4, 0x94, 0x5e, 0x01,
    0xf8, 0x12, 0x7f, 0x00, 0xf4, 0x88, 0x5e, 0x00,
    0xf8, 0x04, 0xff, 0x3f, 0xf4, 0x80, 0xde, 0x3f,
    0xf8, 0x00, 0xff, 0x3f, 0xf4, 0x80, 0xde, 0x3f,
    0x28, 0x00, 0xa5, 0x0a, 0x14, 0x80, 0x52, 0x05,
    0x28, 0x00, 0xa5, 0x0a, 0x14, 0x80, 0x52, 0x05,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};
unsigned char TTextkey_lut [256] =
{
  0,  0,  0,  0,  0,  0,  0,  0,  SKEY_backspace,  SKEY_tab,  0,  0,  0, SKEY_return,  0,  0,
  SKEY_f11,SKEY_f12,  0,  0,  0,  0,  0,  0,  0,  0,  0, SKEY_esc,  0,  0,  0,  0,
  SKEY_tab,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  SKEY_home,SKEY_left,SKEY_up,SKEY_right,SKEY_down,SKEY_page_up,SKEY_page_down,SKEY_end,0,0,0,0,0,0,0,0,
  0,  0,  0,SKEY_insert,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,SKEY_tab,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, SKEY_kp_enter,  0,  0,
  0,  0,  0,  0,  0,SKEY_kp_7,SKEY_kp_4,SKEY_kp_8,SKEY_kp_6,SKEY_kp_2,SKEY_kp_9,SKEY_kp_3,SKEY_kp_1,SKEY_kp_5,SKEY_kp_0,SKEY_kp_decimal,
  0,0,0,0,0,0,0,0,0,0,SKEY_kp_multiply,SKEY_kp_add,0,SKEY_kp_subtract,SKEY_kp_decimal, SKEY_kp_divide,
  SKEY_kp_0,SKEY_kp_1,SKEY_kp_2,SKEY_kp_3,SKEY_kp_4,SKEY_kp_5,SKEY_kp_6,SKEY_kp_7,SKEY_kp_8,SKEY_kp_9,0,0,0,0,SKEY_f1,SKEY_f2,
  SKEY_f3,SKEY_f4,SKEY_f5,SKEY_f6,SKEY_f7,SKEY_f8,SKEY_f9,SKEY_f10,SKEY_f11,SKEY_f12,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,SKEY_kp_subtract,SKEY_kp_divide,SKEY_kp_multiply,SKEY_kp_home,0,SKEY_kp_page_up,0,0,0,SKEY_kp_end,  0,
  SKEY_kp_page_down,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,SKEY_delete
};	/* Extended Keyboard lookup table */

unsigned short NumLockLookUp[SKEY_kp_decimal-SKEY_kp_0+1]=
{
    SKEY_kp_insert, SKEY_kp_end, SKEY_kp_dowm, SKEY_kp_page_down,
    SKEY_kp_left, SKEY_kp_begin, SKEY_kp_right, SKEY_kp_home,
    SKEY_kp_up, SKEY_kp_page_up, SKEY_kp_add, SKEY_kp_begin,
    SKEY_kp_delete
} ;
#else  /* _XTERM */
#define meStdin 0
#endif /* _XTERM */

#if MOUSE
/* Local definitions for mouse handling code */
/* mouseState
 * A integer interpreted as a bit mask that holds the current state of
 * the mouse interaction. */
#define MOUSE_STATE_LEFT         0x0001 /* Left mouse button is pressed */
#define MOUSE_STATE_MIDDLE       0x0002 /* Middle mouse button is pressed */
#define MOUSE_STATE_RIGHT        0x0004 /* Right mouse button is pressed */
#define MOUSE_STATE_BUTTONS      (MOUSE_STATE_LEFT|MOUSE_STATE_MIDDLE|MOUSE_STATE_RIGHT)

int  mouseState = 0;             /* State of the mouse. */

/* mouseKeyState
 * The state of the control keys when the mouse was pressed. */
unsigned short mouseKeyState;     /* State of keyboard control */

static unsigned short mouseKeys[8] = { 0, 1, 2, 0, 3, 0, 0, 0 } ;

#endif


#ifdef _BSD
void
sigAlarm(void)
#else
void
sigAlarm(int sig)
#endif
{
    /*    printf("I got a signal\n") ;*/
    /* Trap Alarm signals under UNIX. Used to do auto saving. */

    /* Note that we use the first timers expire time here and not the actual time.
     * sometimes the itimers fire a little bit early i.e. +-5 msec, to
     * ensure that we do not hang then we force the timer to expire.
     * There is no other way for the timer to expire (that I am aware of) */
    if (timers != NULL)
        timerCheck(timers->abstime);           /* Timer has expired */
}

void
TCAPgetWinSize(void)
{
#ifdef _MEVMS
    struct sensemode tty;
    
    SYS$QIOW(0,meStdin,IO$_SENSEMODE,&tty,0,0,
              &tty.class, 12, 0, 0, 0, 0);
    TTnewWid = tty.scr_wid ;
    TTnewHig = tty.scr_len ;
#else
#ifdef TIOCGWINSZ
    /* BSD-style.  */
    struct winsize size;

    if((ioctl(meStdin,TIOCGWINSZ,&size) == -1) ||
       ((TTnewWid = size.ws_col) <= 0) ||
       ((TTnewHig = size.ws_row) <= 0))
#else
#ifdef TIOCGSIZE
    /* SunOS - style.  */
    struct ttysize size;  

    if((ioctl(meStdin,TIOCGSIZE,&size) == -1) ||
       ((TTnewWid = size.ts_col) <= 0) ||
       ((TTnewHig = size.ts_lines) <= 0))
#endif
#endif
    {
        int  ii ;
        
        if((ii=tgetnum("li")) != -1)
            TTnewHig = ii ;
        else
            TTnewHig = TTnrow + 1 ;
        if((ii=tgetnum("co")) != -1)
            TTnewWid = ii ;
        else
            TTnewWid = TTncol ;
    }
#endif /* _MEVMS */
}

#ifdef _BSD
void
sigSize(void)
#else
void 
sigSize(int sig)
#endif
{
    TCAPgetWinSize() ;
    
    if((TTnewWid != TTncol) || (TTnewHig != TTnrow+1))
        alarmState |= 0x01 ;
}


#ifdef _XTERM

/* XTERMSpecialChar; Draw a special character to the screen. x is the lefthand
 * edge of the character, y is the top of the character. xgc is used for the
 * colors.
 */
void
XTERMSpecialChar (int x, int y, unsigned char cc)
{
    /* Fill in the character */
    switch (cc)
    {
    case 0x09:          /* Tab character -> */
        {
            int xr=x + fwidth - 2, asz=(fhwidth+2) >> 1 ;
            XDrawLine(xdisplay, xwindow, xgc, x+1, y + fhdepth, xr, y + fhdepth);
            XDrawLine(xdisplay, xwindow, xgc, xr,  y + fhdepth, xr - asz, y + fhdepth - asz);
            XDrawLine(xdisplay, xwindow, xgc, xr,  y + fhdepth, xr - asz, y + fhdepth + asz);
            break;
        }
    
    case 0x0b:          /* Line Drawing / Bottom right _| */
        XDrawLine(xdisplay, xwindow, xgc, x, y + fhdepth, x + fhwidth, y + fhdepth);
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y + fhdepth, x + fhwidth, y);
        break;
        
    case 0x0c:          /* Line Drawing / Top right */
        XDrawLine(xdisplay, xwindow, xgc, x, y + fhdepth, x + fhwidth, y + fhdepth);
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y + fhdepth, x + fhwidth, y + fdepth - 1);
        break;
        
    case 0x0d:          /* Line Drawing / Top left */
        XDrawLine(xdisplay, xwindow, xgc, x + fwidth - 1, y + fhdepth, x + fhwidth, y + fhdepth);
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y + fhdepth, x + fhwidth, y + fdepth - 1);
        break;
        
    case 0x0e:          /* Line Drawing / Bottom left |_ */
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y, x + fhwidth, y + fhdepth);
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y + fhdepth, x + fwidth - 1, y + fhdepth);
        break;
        
    case 0x0f:          /* Line Drawing / Centre cross + */
        XDrawLine(xdisplay, xwindow, xgc, x, y + fhdepth, x + fwidth - 1, y + fhdepth);
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y, x + fhwidth, y + fdepth - 1);
        break;
        
    case 0x10:          /* Cursor Arrows / Right */
        {
            XPoint points[3] ;
            points[0].x = x + 1 ;
            points[0].y = y ;
            points[1].x = x + 1 ;
            points[1].y = y + fdepth - 1;
            points[2].x = x + fwidth ;
            points[2].y = y + fhdepth ;
            XFillPolygon(xdisplay, xwindow, xgc, points, 3, Convex, CoordModeOrigin) ;
            break;
        }
        
    case 0x11:          /* Cursor Arrows / Left */
        {
            XPoint points[3] ;
            points [0].x = x + fwidth - 1 ;
            points [0].y = y ;
            points [1].x = x + fwidth - 1 ;
            points [1].y = y + fdepth - 1 ;
            points [2].x = x ;
            points [2].y = y + fhdepth ;
            XFillPolygon(xdisplay, xwindow, xgc, points, 3, Convex, CoordModeOrigin) ;
            break;
        }
        
    case 0x12:          /* Line Drawing / Horizontal line - */
        XDrawLine(xdisplay, xwindow, xgc, x, y + fhdepth, x + fwidth - 1, y + fhdepth);
        break;
        
    case 0x15:          /* Line Drawing / Left Tee |- */
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y, x + fhwidth, y + fdepth - 1);
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y + fhdepth, x + fwidth - 1, y + fhdepth);
        break;
        
    case 0x16:          /* Line Drawing / Right Tee -| */
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y, x + fhwidth, y + fdepth - 1);
        XDrawLine(xdisplay, xwindow, xgc, x, y + fhdepth, x + fhwidth, y + fhdepth);
        break;
        
    case 0x17:          /* Line Drawing / Bottom Tee _|_ */
        XDrawLine(xdisplay, xwindow, xgc, x, y + fhdepth, x + fwidth - 1, y + fhdepth);
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y, x + fhwidth, y + fhdepth);
        break;
        
    case 0x18:          /* Line Drawing / Top Tee -|- */
        XDrawLine(xdisplay, xwindow, xgc, x, y + fhdepth, x + fwidth - 1, y + fhdepth);
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y + fdepth - 1, x + fhwidth, y + fhdepth);
        break;
        
    case 0x19:          /* Line Drawing / Vertical Line | */
        XDrawLine(xdisplay, xwindow, xgc, x + fhwidth, y, x + fhwidth, y + fdepth - 1);
        break;
        
    case 0x1e:          /* Cursor Arrows / Up */
        {
            XPoint points[3] ;
            points [0].x = x - 1 ;
            points [0].y = y + fdepth - 1 ;
            points [1].x = fhwidth + (fwidth & 0x01) ;
            points [1].y = -fadepth ;
            points [2].x = fhwidth + 1 ;
            points [2].y = fadepth ;
            XFillPolygon(xdisplay, xwindow, xgc, points, 3, Convex, CoordModePrevious) ;
            break;
        }
        
    case 0x1f:          /* Cursor Arrows / Down */
        {
            XPoint points[3] ;
            points [0].x = x - 1 ;
            points [0].y = y + 1 ;
            points [1].x = fhwidth + (fwidth & 0x01) ;
            points [1].y = fadepth ;
            points [2].x = fhwidth + 1 ;
            points [2].y = -fadepth ;
            XFillPolygon(xdisplay, xwindow, xgc, points, 3, Convex, CoordModePrevious) ;
            break;
        }
    }
}    

/*
 * XTERMPaint
 * Repaint the screen for the specified region from the frame store.
 * We use the colour and text information from the frame store and 
 * re-paint it on the canvas, thereby refreshing the screen.
 * 
 * srow - Start row 
 * erow - End row
 * scol - Start column
 * ecol - End column
 */
void
XTERMPaint (int srow, int scol, int erow, int ecol)
{
    FRAMELINE      *flp;                /* Frame store line pointer */
    unsigned short *fscp;               /* Frame store colour pointer */
    unsigned char  *fstp;               /* Frame store text pointer */
    unsigned short  ccol;               /* Current colour */
    int col;                            /* Current column position */
    int row;                            /* Current row screen position */
    int tcol;                           /* Text column start */
    int length;                         /* Length of string */
    XGCValues xgcv ;                     /* X Colour values */
    
    /* Process each row in turn until we reach the end of the line */
    if (meSystemCfg & meSYSTEM_FONTFIX)
    {
        unsigned char cc, *sfstp, buff[MAXBUF] ;
        int spFlag ;
        
        for (flp = frameStore + srow; srow < erow; srow++, flp++)
        {
            length = 0;                     /* Initialise the string length */
            col = scol;                     /* Current column becomes start column */
            tcol = col;                     /* Start of the text column */
            row = rowToClient(srow)+ascent,
            
            /* Get pointers aligned into the frame store */
            sfstp = flp->text ;
            fstp = sfstp + scol ;           /* Point to text block */
            fscp = &flp->colour [scol];     /* Point to colour block */
            ccol = *fscp;                   /* Invalid colour to start with */
            spFlag = 0 ;
            while (col < ecol)
            {
                if (*fscp++ != ccol)        /* Change in colour ?? */
                {
                    /* Output the current text item */
                    xgcv.foreground = colTable [FScolourFore(ccol)];
                    xgcv.background = colTable [FScolourBack(ccol)];
                    XChangeGC(xdisplay,xgc,(GCForeground|GCBackground),&xgcv) ;
                    XDrawImageString(xdisplay, xwindow, xgc, 
                                     colToClient(tcol), row,
                                     (char *) buff, length);
                    while(--spFlag >= 0)
                    {
                        while (((cc=sfstp[tcol]) & 0xe0) != 0)
                            tcol++ ;
                        XTERMSpecialChar(tcol*fwidth,row-ascent,cc) ;
                        tcol++ ;
                    }
                    spFlag = 0 ;
                    tcol = col;             /* Move the text position */
                    length = 0;             /* Reset the length */
                    ccol = fscp[-1];        /* Get the next colour */
                }
                if(((cc=*fstp++) & 0xe0) == 0)
                {
                    spFlag++ ;
                    cc = ' ' ;
                }
                buff[length++]=cc;          /* Set & Increment the string length */
                col++;                      /* Next colunm */
            }
            
            /* Output the remaining text item */
            if (length > 0)
            {
                xgcv.foreground = colTable [FScolourFore(ccol)];
                xgcv.background = colTable [FScolourBack(ccol)];
                XChangeGC(xdisplay,xgc,(GCForeground|GCBackground),&xgcv) ;
                XDrawImageString(xdisplay, xwindow, xgc, 
                                 colToClient(tcol), row,
                                 (char *) buff, length);
                while(--spFlag >= 0)
                {
                    while (((cc=sfstp[tcol]) & 0xe0) != 0)
                        tcol++ ;
                    XTERMSpecialChar(tcol*fwidth,row-ascent,cc) ;
                    tcol++ ;
                }
            }
        }
    }
    else
    {
        for (flp = frameStore + srow; srow < erow; srow++, flp++)
        {
            length = 0;                     /* Initialise the string length */
            col = scol;                     /* Current column becomes start column */
            tcol = col;                     /* Start of the text column */
            
            /* Get pointers aligned into the frame store */
            fstp = &flp->text [scol];       /* Point to text block */
            fscp = &flp->colour [scol];     /* Point to colour block */
            ccol = *fscp;                   /* Invalid colour to start with */
            
            while (col < ecol)
            {
                if (*fscp++ != ccol)        /* Change in colour ?? */
                {
                    /* Output the current text item */
                    xgcv.foreground = colTable [FScolourFore(ccol)];
                    xgcv.background = colTable [FScolourBack(ccol)];
                    XChangeGC(xdisplay,xgc,(GCForeground|GCBackground),&xgcv) ;
                    XDrawImageString(xdisplay, xwindow, xgc, 
                                     colToClient(tcol),
                                     rowToClient(srow)+ascent,
                                     (char *) fstp, length);
                    fstp += length;         /* Move the text pointer */
                    tcol = col;             /* Move the text position */
                    length = 0;             /* Reset the length */
                    ccol = fscp[-1];        /* Get the next colour */
                }
                length++;                   /* Increment the string length */
                col++;                      /* Next colunm */
            }
            
            /* Output the remaining text item */
            if (length > 0)
            {
                xgcv.foreground = colTable [FScolourFore(ccol)];
                xgcv.background = colTable [FScolourBack(ccol)];
                XChangeGC(xdisplay,xgc,(GCForeground|GCBackground),&xgcv) ;
                XDrawImageString(xdisplay, xwindow, xgc, 
                                 colToClient(tcol),
                                 rowToClient(srow)+ascent,
                                 (char *) fstp, length);
            }
        }
    }
}

/* following are used for incremental Selection getting */
static unsigned char *meClipBuff=NULL ;
static int meClipSize=0 ;

/* The xterm XEvent handler */
void
meXEventHandler(void)
{
    XEvent event ;
    
    /* Get the next event - wait if necesary */
    XNextEvent(xdisplay,&event);
    /* printf("Got event %d\n",event.type) ; */
    switch(event.type)
    {
    case ConfigureNotify:
        /* window has been resized, change width and height to send to
         * draw_text and draw_graphics */
        {
            /* Get the width and heigth back and setup the TTmrow etc */
            int ww, hh ;
            
            sizeHints.height = event.xconfigure.height ;
            sizeHints.width  = event.xconfigure.width ;
            hh = event.xconfigure.height / fdepth ;
            ww = event.xconfigure.width / fwidth ;
/*            printf("Got event2 Config %d %d\n",hh,ww) ;*/
            /*        printf("Got configure event! (%d,%d)\n",TTncol,TTnrow) ;*/
            /* Disable the window resize until BOTH width and height changes
             * have been established. Both LINUX and SUN suffer from severe
             * beating between the client and server when the resize requests
             * are split. Allow the new sizes to be computed and then inform
             * the server in one invocation. */
            disableResize = 1;          /* Disable X reconfiguration */
            changeScreenWidth(TRUE,ww); /* Change width */
            changeScreenDepth(TRUE,hh); /* Change depth */
            disableResize = 0;          /* Re-enable the resize */
            
            /* Change the size of the window now that both sizes have been
             * established. Only perform the resize if there is something to 
             * change */
            if ((hh != TTnrow+1) || (ww != TTncol))
            {
                sizeHints.height = fdepth*(TTnrow+1) ;
                sizeHints.width  = fwidth*TTncol ;
                XResizeWindow(xdisplay,xwindow,sizeHints.width,sizeHints.height) ;
            }
        }
        break;
    case Expose:
        /*
         * All, or part of the window has been exposed. probably caused by
         * another window passing ontop of the MicroEmacs canvas, or we have
         * just been exposed.
         * 
         * Update the canvas from the frame store, there is no need to 
         * regenerate the screen, simply repaint those canval pixels which
         * have been corrupted by X over-painting another window. 
         * 
         * Note that we use the 'count' in the XExposeEvent. This tells us
         * if another Expose event is coming on the input queue when non-zero. 
         * In this case we hold off on the paint and remember the largest 
         * bounding box that contains the region to be painted. Only when it
         * reaches zero do we actually perform the paint. This allows us to 
         * optimise the painting otherwise we may over paint the same region
         * multiple times. Who knows what the user is doing !!
         * 
         * Note that keeping a single bounding box may mean that we update
         * too much of the screen, however in most cases multiple paints
         * are in adjacent regions.
         * 
         * Jon Green 28/06/97
         */
        {
            static int sscol= -1;       /* History - Start column */
            static int ssrow;           /* History - Start row */
            static int secol;           /* History - End column */
            static int serow;           /* History - End row */
            int scol;                   /* Current - Start column */
            int srow;                   /* Current - Start row */
            int ecol;                   /* Current - End column */
            int erow;                   /* Current - End row */
            
            /* Compute the start and end column widths. For the end 
             * column then a rounding operation is performed to ensure
             * that the whole character is covered */
            scol = clientToCol(event.xexpose.x); 
            ecol = clientToCol(event.xexpose.x+event.xexpose.width+fwidth-1);
            if (ecol > TTncol)
                ecol = TTncol;
            srow = clientToRow(event.xexpose.y);
            erow = clientToRow(event.xexpose.y+event.xexpose.height+fdepth-1);
            if (erow > (TTnrow+1))
                erow = (TTnrow+1);
            
            /*
             * Determine if the paint should be held off, other paints
             * are on their way. If the paint is to be held off then
             * remeber the extents of the bounding box, otherwise 
             * do the paint.
             */
            if (sscol == -1)            /* No historical bounding information */
            {
                if (event.xexpose.count == 0)   /* Last of the expose events ?? */
                    XTERMPaint (srow, scol, erow, ecol); 
                else                    /* More to come - save bounding box */
                {
                    sscol = scol;
                    secol = ecol;
                    ssrow = srow;
                    serow = erow;
                }
            }
            /* A historical bounding box exists. */
            else
            {
                /* Update the historical bounding box infomation by using the
                 * maximum and minimum values of the existing and current 
                 * Exposure boxes. */
                if (scol < sscol)
                    sscol = scol;
                if (ecol > secol)
                    secol = ecol;
                if (srow < ssrow)
                    ssrow = srow;
                if (erow > serow)
                    serow = erow;
                /* If this is the last of the Expose events then initiate
                 * a paint to redraw the screen. */
                if (event.xexpose.count == 0)
                {
                    XTERMPaint (ssrow, sscol, serow, secol);
                    sscol = -1;         /* Reset the history to none */
                }
            }
            if((cursorState >= 0) && blinkState)
                XTERMshowCur() ;
            XFlush(xdisplay) ;    
        }
        break;
    
    case MotionNotify:                  /* Mouse has moved. */
        if(meMouseCfg & meMOUSE_ENBLE)
        {
            /* Collect the position of the mouse. Require the row/column mouse
             * position. Also require the fractional bits incase we are scrolling
             * 
             * Really we should re-evaluate the buttons here. However X-Windows
             * does not seemed to have aquired an incorrect state (i.e. button
             * state mis-represented). I will leave it for the time being (JDG)
             */
            unsigned short cc;                  /* Character code */
            unsigned int   arg;                 /* Decode key argument */
            mouse_X = event.xmotion.x / fwidth ;
            mouse_Y = event.xmotion.y / fdepth ;
            mouse_dX = ((event.xmotion.x - (mouse_X * fwidth)) << 8) / fwidth;
            mouse_dY = ((event.xmotion.y - (mouse_Y * fdepth)) << 8) / fdepth;
            /* Check for a mouse-move key */
            cc = (ME_SPECIAL | mouseKeyState |
                  (SKEY_mouse_move+mouseKeys[mouseState&MOUSE_STATE_BUTTONS])) ;
            /* Are we after all movements or mouse-move bound ?? */
            if((TTallKeys & 0x1) || (!TTallKeys && (decode_key(cc,&arg) != -1)))
                addKeyToBuffer(cc) ;        /* Add key to keyboard buffer */
        }
        break;
    case FocusIn:
        TTfocus = 1 ;
        if((cursorState >= 0) && blinkState)
        {
            if(cursorBlink)
                TThandleBlink(2) ;
            else
                XTERMshowCur() ;
            XFlush(xdisplay) ;
        }
        break ;
        
    case FocusOut:
        TTfocus = 0 ;
        if(cursorState >= 0)
        {
            /* because the cursor is a part of the solid cursor we must
             * remove the old one first and then redraw
             */
            if(blinkState)
                XTERMhideCur() ;
            blinkState = 1 ;
            XTERMshowCur() ;
            XFlush(xdisplay) ;
        }
        break ;

    case ButtonPress:
        if(meMouseCfg & meMOUSE_ENBLE)
        {
            unsigned int   bb ;
            unsigned short ss ;
            /* Collect the position of the mouse. Require the row/column mouse
             * position. Also require the fractional bits incase we are scrolling */
            mouse_X = event.xbutton.x / fwidth ;
            mouse_Y = event.xbutton.y / fdepth ;
            mouse_dX = ((event.xbutton.x - (mouse_X * fwidth)) << 8) / fwidth;
            mouse_dY = ((event.xbutton.y - (mouse_Y * fdepth)) << 8) / fdepth;
            bb = 1 << (event.xbutton.button - 1) ;
            
            /* Add the presense of the button to the mouseState. */
            mouseState |= bb ;
            
            /* Generate keycode and shunt on the key queue */
            ss = event.xbutton.state ;
            mouseKeyState = ((ss & 0x01) << 8) | ((ss & 0x0C) << 7);
            ss = (ME_SPECIAL | (SKEY_mouse_pick_1+mouseKeys[bb]-1) | mouseKeyState) ;
            addKeyToBuffer(ss) ;
        }
        break ;
    case ButtonRelease:
        if(meMouseCfg & meMOUSE_ENBLE)
        {
            unsigned int   bb ;
            unsigned short ss ;
            /* Collect the position of the mouse. Require the row/column mouse
             * position. Also require the fractional bits incase we are scrolling */
            mouse_X = event.xbutton.x / fwidth ;
            mouse_Y = event.xbutton.y / fdepth ;
            mouse_dX = ((event.xbutton.x - (mouse_X * fwidth)) << 8) / fwidth;
            mouse_dY = ((event.xbutton.y - (mouse_Y * fdepth)) << 8) / fdepth;
            bb = 1 << (event.xbutton.button - 1) ;
            
            /* Remove the presense of the button from the mouseState. */
            mouseState &= ~bb ;
            
            /* Generate keycode and shunt on the key queue */
            ss = event.xbutton.state ;
            mouseKeyState = ((ss & 0x01) << 8) | ((ss & 0x0C) << 7);
            ss = (ME_SPECIAL | (SKEY_mouse_drop_1+mouseKeys[bb]-1) | mouseKeyState) ;
            addKeyToBuffer(ss) ;
        }
        break ;
    case KeyPress:
        {
            unsigned short ii, ss ;
            KeySym         keysym ;
            
            ss = event.xkey.state ;
            keysym = XLookupKeysym((XKeyEvent *) &event,(ss&0x1)) ;
/*            printf("got %x ss=%x\n",keysym, ss) ;*/
            if((keysym == 0) && (ss&0x1))
                keysym = XLookupKeysym((XKeyEvent *) &event,0) ;
            
            /* Map Mod2 which is ALT-GR onto A-C */
#if (defined _SUNOS_X86)
            /* SunOS mapped to modifier key 2 */
            if (ss & 0x10)
                ss = (ss & ~0x10) | 0xc;
#else 
#if (defined _LINUX)
            /* Linux mapped to modifier key 3 */
            if (ss & 0x20)
                ss = (ss & ~0x20) | 0xc;
#endif
#endif
              if(keysym > 0xff)
              {
/*                printf("Got ext %x %x -> %x;\n",*/
/*                       event.xkey.state,*/
/*                       event.xkey.keycode,keysym) ;*/
                keysym = TTextkey_lut[keysym & 0xff] ;
                if(keysym == 0)
                    break ;
                /* Cope with the num lock state on the key pad */
                if(!(ss & 0x10) && (keysym >= SKEY_kp_0) && (keysym <= SKEY_kp_decimal))
                    keysym = NumLockLookUp[keysym-SKEY_kp_0] ;
                
/*                if(!(ss & 0x0D) && */
/*                   ((keysym >= 0x1B) && (keysym <= 0x7f)))*/
/*                    ii = keysym ;*/
/*                else*/
                    ii = (ME_SPECIAL | keysym | ((ss & 0x01) << 8) | ((ss & 0x0C) << 7)) ;
            }
            else
            {
                keysym &= 0xff ;
                if(ss & 0x0C)
                {
                    keysym = toUpper(keysym) ;
                    if(((ss & 0x0C) != 4) ||
                       ((keysym < 'A') || (keysym > '_')))
                    {
                        keysym = toLower(keysym) ;
                        ii = keysym | ((ss & 0x0C) << 7) ;
                    }
                    else
                        ii = keysym-'@' ;
                }
                else
                {
                    if(ss & 0x02)
                    {
                        if(isLower(keysym))
                            keysym = toUpper(keysym) ;
                        else if(isUpper(keysym))
                            keysym = toLower(keysym) ;
                    }
                    ii = keysym ;
                }
            }
            /*        printf("Got %x : %x %x -> %x\n",keysym,*/
            /*               event.xkey.state,*/
            /*               event.xkey.keycode,ii) ;*/
            if(ii == 0x07)
            {
                if(macbug < 0)
                {
                    macbug = 1 ;
                    break ;
                }
                TTbreakFlag = 1 ;
            }
            addKeyToBuffer(ii) ;
            break ;
        }
    case SelectionClear:
        if((event.xselectionclear.window == xwindow) &&
           (event.xselection.selection == XA_PRIMARY))
            clipState &= ~CLIP_OWNER ;
        break ;
        
    case SelectionRequest:
        {
            XSelectionEvent reply;
            
            /* printf("Target = %d %s, string %d\n",event.xselectionrequest.target,*/
            /*        XGetAtomName(xdisplay, event.xselectionrequest.target),XA_STRING) ;*/
            reply.type = SelectionNotify;
            reply.requestor = event.xselectionrequest.requestor ;
            reply.selection = event.xselectionrequest.selection ;
            reply.time = event.xselectionrequest.time ;
            reply.target = event.xselectionrequest.target ;
            reply.property = None ;
            
            if((event.xselectionrequest.selection == XA_PRIMARY) &&
               ((event.xselectionrequest.target == XA_STRING) ||
                (event.xselectionrequest.target == meAtoms[meATOM_TARGETS])) &&
               (klhead != NULL))
            {
                static unsigned char *data=NULL ;
                static int dataLen=0 ;
                unsigned char *ss, *dd, cc ;
                KILL *killp ;
                int   len ;
                    
                len = 0 ;
                killp = klhead->kill;
                while(killp != NULL)
                {
                    len += strlen((char *) killp->data) ;
                    killp = killp->next;
                }
                if((dataLen <= len) &&
                   ((ss = (unsigned char *) malloc(len+1)) != NULL))
                {
                    meNullFree(data) ;
                    data = ss ;
                    dataLen = len+1 ;
                }
                if(dataLen > len)
                {
                        ss = data ;
                    killp = klhead->kill;
                    while(killp != NULL)
                    {
                        dd = killp->data ;
                        while((cc = *dd++))
                            *ss++ = cc ;
                        killp = killp->next ;
                    }
                    *ss = '\0' ;
                    reply.property = event.xselectionrequest.property ;
                    XChangeProperty(xdisplay,reply.requestor,reply.property,reply.target,
                                    8,PropModeReplace,data,len);
                }
            }
            XSendEvent(xdisplay,reply.requestor,False,NULL,(XEvent *) &reply) ;
            break;
        }
    case SelectionNotify:
        {
            unsigned long nitems, left;
            unsigned char *buff, *dd ;
            Atom type ;
            int  fmt ;     
            
            if((event.xselection.selection == XA_PRIMARY) &&
               (event.xselection.property == meAtoms[meATOM_COPY_TEXT]) &&
               (XGetWindowProperty(xdisplay,xwindow,meAtoms[meATOM_COPY_TEXT],0,0x1fffffffL,False,AnyPropertyType,
                                   &type, &fmt, &nitems, &left, &buff) == Success))
            {
                if(type == meAtoms[meATOM_MULTIPLE])
#ifndef NDEBUG
                    printf("Currently don't support multiple\n")
#endif
                          ;
                else if((type == meAtoms[meATOM_INCR]) && (fmt == 32) && (nitems > 0))
                {
                    nitems = ((long *) buff)[0] ;
                    XFree(buff) ;
                    /* always ksave, don't want to glue 'em together */
                    ksave();
                    if((dd = kaddblock(nitems)) != NULL)
                    {
                        dd[0] = '\0' ;
                        thisflag = CFKILL ;
                        meClipSize = nitems ;
                        meClipBuff = dd ;
                        /* Start the text transfer */
                        XDeleteProperty(xdisplay,xwindow,meAtoms[meATOM_COPY_TEXT]);
                        XFlush(xdisplay);
                        /* don't flag that we've got the clipboard yet cos we haven't */
                        break ;
                    }
                }
                else if((type == XA_STRING) && (fmt == 8) && (nitems > 0))
                {
                    if((klhead == NULL) || (klhead->kill == NULL) ||
                       (klhead->kill->next != NULL) || 
                       strncmp((char *) klhead->kill->data,(char *)buff,nitems) ||
                       (klhead->kill->data[nitems] != '\0'))
                    {
                        /* always ksave, don't want to glue 'em together */
                        ksave();
                        if((dd = kaddblock(nitems)) != NULL)
                        {
                            strncpy((char *)dd,(char *)buff,nitems) ;
                            dd[nitems] = '\0' ;
                        }
                        thisflag = CFKILL;
                    }
                }
                XFree(buff) ;
            }
            /* Always flag that we got the event */
            alarmState |= 0x10 ;
            break ;
        }
        
    case PropertyNotify:
        if ((meClipSize > 0) && (event.xproperty.state == PropertyNewValue) && 
            (event.xproperty.atom == meAtoms[meATOM_COPY_TEXT]))
        {
            unsigned long nitems, left;
            unsigned char *buff ;
            Atom type ;
            int  fmt, ret ;
            
            ret = XGetWindowProperty(xdisplay,xwindow,meAtoms[meATOM_COPY_TEXT],
                                     0L,0x1fffffffL,True,AnyPropertyType,
                                     &type, &fmt, &nitems, &left, &buff) ;
            
            if((ret == Success) && (type == XA_STRING) && (fmt == 8))
            {
                if(nitems == 0)
                {
                    /* got all we're going to */
                    meClipSize = 0 ;
                    alarmState |= 0x10 ;
                }
                else
                {
                    if(nitems >= meClipSize)
                    {
                        /* flag that we have the clipboard */
                        nitems = meClipSize ;
                        alarmState |= 0x10 ;
                    }
                    memcpy(meClipBuff,buff,nitems) ;
                    meClipSize -= nitems ;
                    meClipBuff += nitems ;
                    *meClipBuff = '\0' ;
                    XFree(buff) ;
                }
            }
        }
        break ;

    case ClientMessage:
        if((event.xclient.message_type == meAtoms[meATOM_WM_PROTOCOLS]) && 
           (event.xclient.format == 32))
        {
            if(event.xclient.data.l[0] == meAtoms[meATOM_WM_DELETE_WINDOW])
            {
                /* Use the normal command to save buffers and exit
                 * if it doesn't exit then carry on as normal
                 */
                saveExitEmacs(0,1) ;
            }
            else if(event.xclient.data.l[0] == meAtoms[meATOM_WM_SAVE_YOURSELF])
            {
                /* printf("Got a SAVE_YOURSELF\n") ;*/
            }
        }
        break ;
    default:
        /* all events selected by StructureNotifyMask
         * except ConfigureNotify are thrown away here,
         * since nothing is done with them */
        break;
    } /* end switch */
}


#endif



/*****************************************************************************
 *
 * TCAP FUNCTIONS
 *
 *****************************************************************************/



int
TCAPstart(void)
{
    char *p ;
    char tcbuf[1024];
    char *tv_stype;
    char err_str[72];
    int  ii ;
    
#ifdef _USG
#ifndef _XTERM
#ifdef _TERMIOS
    tcgetattr (0, &otermio);
#else
    ioctl(0, TCGETA, &otermio) ;
#endif
#endif
#endif
    /* default to use fonts - usually supports reverse */
    meSystemCfg &= ~meSYSTEM_RGBCOLOR ;
    meSystemCfg |= (meSYSTEM_CONSOLE|meSYSTEM_FONTS) ;
    if((tv_stype = getenv("TERM")) == NULL)
    {
        puts("Environment variable TERM not defined");
        meExit(1);
    }

    if((tgetent(tcbuf, tv_stype)) != 1)
    {
        sprintf(err_str, "Unknown terminal type [%s]", tv_stype);
        puts(err_str);
        meExit(1);
    }
    TCAPgetWinSize() ;
    TTmrow = TTnewHig ;
    TTmcol = TTnewWid ;
    
    TTnrow = TTmrow - 1 ;
    TTncol = TTmcol;

    p = tcapbuf;
    CL = tgetstr("cl", &p);
    CM = tgetstr("cm", &p);
    SE = tgetstr("se", &p);
/*    VI = tgetstr("vi", &p);*/
/*    VE = tgetstr("ve", &p);*/
#ifdef _TCAPFONT
    /* Always try to get the font - bold is also used for the
     * light color support */
    for(ii=0 ; ii<FNTNUMFONTS ; ii++)
        fontComm[ii] = tgetstr(fontStr[ii],&p) ;
#endif
    
    if((CL == NULL) || (CM == NULL))
    {
        sprintf(err_str, "%s termcap lacks cl or cm entry",tv_stype);
        puts(err_str);
        meExit(1);
    }

    if (p >= &tcapbuf[TCAPSLEN])
    {
        sprintf(err_str, "%s termcap longer than %d characters",
                tv_stype, TCAPSLEN);
        puts(err_str);
        meExit(1);
    }
    /* Try and setup some of the standard keys like the cursor keys */
    {
        char buf[20] ;
        unsigned short ii, sl[20] ;
        
        for(ii=0 ; ii<SKEY_MAX ; ii++)
        {
            if(tcapSpecKeyDefs[ii] != NULL)
                translateKeyAdd(&TTtransKey,charListToShorts(sl,tcapSpecKeyDefs[ii]),
                                sl,ME_SPECIAL|ii) ;
        }
        for(ii=0 ; ii<SKEY_MAX ; ii++)
        {
            p = buf ;
            if((tcapSpecKeyStrs[ii] != NULL) && ((p=tgetstr(tcapSpecKeyStrs[ii], &p)) != NULL))
                translateKeyAdd(&TTtransKey,charListToShorts(sl,(unsigned char *) p),
                                sl,(ii|ME_SPECIAL)) ;
            else
                tcapSpecKeyStrs[ii] = NULL ;
        }
        if((tcapSpecKeyStrs[SKEY_page_up] == NULL) && ((p=tgetstr("kP", &p)) != NULL))
        {
            tcapSpecKeyStrs[SKEY_page_up] = "kP" ;
            translateKeyAdd(&TTtransKey,charListToShorts(sl,(unsigned char *) p),
                            sl,(SKEY_page_up|ME_SPECIAL)) ;
        }
        if((tcapSpecKeyStrs[SKEY_page_down] == NULL) && ((p=tgetstr("kN", &p)) != NULL))
        {
            tcapSpecKeyStrs[SKEY_page_down] = "kN" ;
            translateKeyAdd(&TTtransKey,charListToShorts(sl,(unsigned char *) p),
                            sl,(SKEY_page_down|ME_SPECIAL)) ;
        }
    }
    /* Switch off the vertical window scroll bar */
    gsbarmode &= ~WMVBAR ;
    {
        struct sigaction sa ;
        sigemptyset(&sa.sa_mask) ;
        sa.sa_flags=0 ;
        sa.sa_handler=sigSize ;
        sigaction(SIGWINCH,&sa,NULL) ;
    }
    return TCAPopen() ;
}

#ifdef _XTERM

/*
 * TTinitMouse
 * Sort out what to do with the mouse buttons.
 */
void
TTinitMouse(void)
{
    if(meSystemCfg & meSYSTEM_CONSOLE)
        meMouseCfg &= ~meMOUSE_ENBLE ;
    else if(meMouseCfg & meMOUSE_ENBLE)
    {
        static unsigned char meCurCursor=0 ;
        static Cursor        meCursors[meCURSOR_COUNT]={0,0,0,0,0,0,0} ;
        static unsigned char meCursorChar[meCURSOR_COUNT]={
            0,XC_arrow,XC_xterm,XC_crosshair,XC_hand2,XC_watch,XC_pirate} ;
        unsigned char cc ;
        int b1, b2, b3 ;
    
        if(meMouseCfg & meMOUSE_SWAPBUTTONS)
            b1 = 3, b3 = 1 ;
        else
            b1 = 1, b3 = 3 ;
        if((meMouseCfg & meMOUSE_NOBUTTONS) > 2)
            b2 = 2 ;
        else
            b2 = b3 ;
        mouseKeys[1] = b1 ;
        mouseKeys[2] = b2 ;
        mouseKeys[4] = b3 ;
        
        cc = (unsigned char) ((meMouseCfg & meMOUSE_ICON) >> 16) ;
        if(cc >= meCURSOR_COUNT)
            cc = 0 ;
        if(cc != meCurCursor)
        {
            if(meCurCursor)
            {
                XUndefineCursor(xdisplay,xwindow) ;
                meCurCursor = 0 ;
            }
            if(cc && ((meCursors[cc] != 0) ||
                      ((meCursors[cc] = XCreateFontCursor(xdisplay,meCursorChar[cc])) != 0)))
            {
                XDefineCursor(xdisplay,xwindow,meCursors[cc]) ;
                meCurCursor = cc ;
            }
        }
    }
}

/* Heres the xterm equivalent, note that its done in two stages */
static int
XTERMstart(void)
{
    XrmDatabase  rdb ;
    XrmValue     retVal ;
    XGCValues    xgcv ;
    XFontStruct *font ;
    Pixmap       iconPixmap=NULL ;
    Font         fontId ;
    char        *retType ;
    char        *xdefs ;
    int          xx, yy ;
    unsigned int ww, hh  ;
    char        *ss ;
    
    XSetLocaleModifiers ("");
    {
        char *disp ;
        if((disp=getenv("DISPLAY")) == NULL)
            disp = ":0.0" ;
        if((xdisplay = XOpenDisplay(disp)) == NULL)
        {
            fprintf(stderr,"MicroEmacs: Failed to open DISPLAY \"%s\"\n",disp) ;
            exit(1) ;
        }
    }
    meStdin = ConnectionNumber(xdisplay);
    xscreen = DefaultScreen(xdisplay) ;
    xcmap   = DefaultColormap(xdisplay,xscreen) ;
    
    sizeHints.flags = PSize | PResizeInc | PMinSize | PBaseSize ;
    sizeHints.max_height = DisplayHeight(xdisplay,xscreen) ;
    sizeHints.max_width  = DisplayWidth(xdisplay,xscreen) ;
    
    XrmInitialize ();
    xdefs = XResourceManagerString(xdisplay);
    if (xdefs != NULL)
        rdb = XrmGetStringDatabase (xdefs);
    else
    {
        char buff[1048] ;
        strcpy(buff,(homedir != NULL) ? homedir:".") ;
        strcat(buff,"/.Xdefaults") ;
        rdb = XrmGetFileDatabase(buff);
    }
    if(XrmGetResource(rdb,"MicroEmacs.font","MicroEmacs.Font",&retType,&retVal) &&
       !strcmp(retType,"String"))
        ss = retVal.addr ;
    else
        ss = "-*-fixed-medium-r-normal--15-*-*-*-c-90-iso8859-1" ;
    if((font=XLoadQueryFont(xdisplay,ss)) == NULL)
        return FALSE ;
    fontId  = font->fid ;
    ascent  = font->ascent ;
    fdepth  = ascent + font->descent ;
    fwidth  = font->max_bounds.width ;
    fhdepth = fdepth >> 1 ;
    fhwidth = fwidth >> 1 ;
    if((fadepth = fwidth+1) > fdepth)
        fadepth = fdepth ;
    
    sizeHints.height_inc = fdepth ;
    sizeHints.width_inc  = fwidth ;
    sizeHints.min_height = fdepth*4 ;
    sizeHints.min_width  = fwidth*10 ;
    sizeHints.base_height = fdepth ;
    sizeHints.base_width  = fwidth ;

    XFreeFontInfo(NULL,font,1) ;
    
    /* Set the default geometry, then look for an override */
    ww = 80 ;
    hh = 50 ;
    xx = 0 ;
    yy = 0 ;
    if(XrmGetResource(rdb,"MicroEmacs.geometry","MicroEmacs.Geometry",&retType,&retVal) &&
       !strcmp(retType,"String"))
        sscanf(retVal.addr,"%dx%d+%d+%d",&ww,&hh,&xx,&yy) ;
    ww *= fwidth ;
    hh *= fdepth ;
    if(hh > sizeHints.max_height)
        hh = (sizeHints.max_height/fdepth) * fdepth ;
    if(ww > sizeHints.max_width)
        ww = (sizeHints.max_width/fwidth) * fwidth ;
    
    sizeHints.x = xx ;
    sizeHints.y = yy ;
    sizeHints.height = hh ;
    sizeHints.width  = ww ;
    TTnrow = TTmrow = hh / fdepth ;
    TTncol = TTmcol = ww / fwidth ;
    TTnrow-- ;
    xwindow = XCreateSimpleWindow(xdisplay,RootWindow(xdisplay,xscreen),xx,yy,ww,hh,0,
                                 WhitePixel(xdisplay,xscreen),BlackPixel(xdisplay,xscreen)) ;
    
    XSetWMNormalHints(xdisplay,xwindow,&sizeHints);
    /* Map the window a.s.a.p. cos officially we can't draw to the window until we
     * get an Expose event. As this is not checked for by mapping now there is
     * less chance of this being a problem.
     */
    XMapWindow(xdisplay,xwindow) ;
    
    {
        static char* meAtomNames[7] = {
            "WM_DELETE_WINDOW",
            "WM_SAVE_YOURSELF",
            "WM_PROTOCOLS",
            "__COPY_TEXT",
            "TARGETS",
            "INCR",
            "MULTIPLE"
        } ;
        int ii ;
        for(ii=0 ; ii<7 ; ii++)
            meAtoms[ii] = XInternAtom(xdisplay,meAtomNames[ii], FALSE);
    }
    XSetWMProtocols(xdisplay,xwindow,meAtoms,2) ;
    
    if(XrmGetResource(rdb,"MicroEmacs.name","MicroEmacs.Name",&retType,&retVal) &&
       !strcmp(retType,"String") &&
       ((ss = strdup(retVal.addr)) != NULL))
        meName = ss ;
    TTtitleText(NULL) ;
    
    if(XrmGetResource(rdb,"MicroEmacs.iconname","MicroEmacs.IconName",&retType,&retVal) &&
       !strcmp(retType,"String"))
        ss = retVal.addr ;
    else
        ss = meName ;
    XSetIconName(xdisplay,xwindow,ss);
    
    if(XrmGetResource(rdb,"MicroEmacs.icon","MicroEmacs.Icon",&retType,&retVal) &&
       !strcmp(retType,"String"))
    {
        unsigned int i1,i2 ;
        int          i3,i4 ;

        switch(XReadBitmapFile(xdisplay,xwindow,retVal.addr,&i1,&i2,
                               &iconPixmap,&i3,&i4))
        {
        case BitmapOpenFailed:
            fprintf(stderr,"Failed to open bitmap %s\n",retVal.addr) ;
            break ;
        case BitmapFileInvalid:
            fprintf(stderr,"Invalid bitmap file %s\n",retVal.addr) ;
            break ;
        }
    }
    else
        iconPixmap = XCreatePixmapFromBitmapData
              (xdisplay,xwindow,(char *) iconBits,iconWidth,iconHeight,
               WhitePixel(xdisplay,xscreen),BlackPixel(xdisplay,xscreen),1);
        
    if(iconPixmap != NULL)
    {
        XWMHints wmHints ;
        wmHints.flags = IconPixmapHint ;
        wmHints.icon_pixmap = iconPixmap ;
        XSetWMHints(xdisplay,xwindow,&wmHints) ;
    }
    xgcv.font = fontId ;
    xgc = XCreateGC(xdisplay,xwindow,GCFont,&xgcv) ;
    /* To get the mouse positional information then we register for
     * "PointerMotionMask" events. I would prefer the Hint variety
     * if they generate less events ?? This does not seem to operate 
     * under LINUX - am I using it incorrectly  ?? (I have not got an X-Book 
     * here). The "PointerMotionMask" seems to do the business  - JDG */
    XSelectInput(xdisplay,xwindow,(ExposureMask|StructureNotifyMask|KeyPressMask|
                                   ButtonPressMask|ButtonReleaseMask|PointerMotionMask|
                                   FocusChangeMask|PropertyChangeMask)) ;
    /* Free off the resource database */
    XrmDestroyDatabase(rdb) ;
    
    return TRUE ;
}

int 
XTERMstartStage2(void)
{
    /* Create the cursor */
    XTERMshowCur();                       /* Show the cursor */
    return TRUE ;
}


/* Function only needed if we have xterm and termcap, its purpose
 * is to work out where to call XTERMstart or TCAPstart
 */
int
TTstart(void)
{
    char *tt ;

#ifdef _USG
#ifdef _TERMIOS
    tcgetattr (0, &otermio);
#else
    ioctl(0, TCGETA, &otermio) ;
#endif
#endif
    
    if((meSystemCfg & meSYSTEM_CONSOLE) ||
       (((tt = getenv("TERM")) != NULL) &&
        (tt[0] == 'v') && (tt[1] == 't')))
        return TCAPstart() ;
    return XTERMstart() ;
}
#endif

int
TCAPopen(void)
{
#ifdef _MEVMS
    struct  dsc$descriptor  idsc;
    struct  dsc$descriptor  odsc;
    char    oname[40];
    int     iosb[2];
    int     status;

    odsc.dsc$a_pointer = "TT";
    odsc.dsc$w_length  = strlen(odsc.dsc$a_pointer);
    odsc.dsc$b_dtype        = DSC$K_DTYPE_T;
    odsc.dsc$b_class        = DSC$K_CLASS_S;
    idsc.dsc$b_dtype        = DSC$K_DTYPE_T;
    idsc.dsc$b_class        = DSC$K_CLASS_S;
    do {
        idsc.dsc$a_pointer = odsc.dsc$a_pointer;
        idsc.dsc$w_length  = odsc.dsc$w_length;
        odsc.dsc$a_pointer = &oname[0];
        odsc.dsc$w_length  = sizeof(oname);
        status = LIB$SYS_TRNLOG(&idsc, &odsc.dsc$w_length, &odsc);
        if (status!=SS$_NORMAL && status!=SS$_NOTRAN)
            meExit(status);
        if (oname[0] == 0x1B) {
            odsc.dsc$a_pointer += 4;
            odsc.dsc$w_length  -= 4;
        }
    } while (status == SS$_NORMAL);
    status = SYS$ASSIGN(&odsc, &iochan, 0, 0);
    if (status != SS$_NORMAL)
        meExit(status);
    status = SYS$QIOW(EFN, iochan, IO$_SENSEMODE, iosb, 0, 0,
                          oldmode, sizeof(oldmode), 0, 0, 0, 0);
    if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
        meExit(status);
    newmode[0] = oldmode[0];
    newmode[1] = oldmode[1] | TT$M_NOECHO;
    newmode[1] &= ~(TT$M_TTSYNC|TT$M_HOSTSYNC);
    newmode[2] = oldmode[2] | TT2$M_PASTHRU;
    status = SYS$QIOW(EFN, iochan, IO$_SETMODE, iosb, 0, 0,
                      newmode, sizeof(newmode), 0, 0, 0, 0);
    if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
        meExit(status);
    term.t_nrow = (newmode[1]>>24) - 1;
    term.t_ncol = newmode[0]>>16;

#endif

#ifdef _USG
    ntermio = otermio;

/*    ntermio.c_lflag &= ~(ISIG|ICANON|ECHO);*/
    ntermio.c_lflag &= ~(ISIG|ICANON|ECHO|IEXTEN);
/*    ntermio.c_iflag &= ~(IXON|ICRNL);*/
    ntermio.c_iflag &= ~(IXON|IXANY|INLCR|INPCK|ICRNL|ISTRIP);
#ifdef TAB3
    ntermio.c_oflag &= ~(ONLCR|TAB3);
#else
    ntermio.c_oflag &= ~ONLCR ;
#endif
    ntermio.c_iflag |= IGNBRK ;
    ntermio.c_cc[VMIN] = 1 ;
    ntermio.c_cc[VTIME] = 0 ;
/*    ntermio.c_cc[VINTR] = 7 ;*/
#ifdef _TERMIOS
    tcsetattr (meStdin, TCSAFLUSH, &ntermio);
#else
    ioctl(0, TCSETA, &ntermio); /* and activate them */
#endif
#endif

#if (defined _V7) || (defined _BSD)
    gtty(0, &ostate);                       /* save old state */
    memcpy(&nstate,&ostate,sizeof(struct sgttyb));     /* get base of new state */
#if     CBMODE
    nstate.sg_flags |=  CBREAK;
    nstate.sg_flags &= ~(ECHO | CRMOD | XTABS);
#else
    nstate.sg_flags |= RAW;
    nstate.sg_flags &= ~(ECHO|CRMOD);       /* no echo for now... */
#endif  /* CBMODE */
    stty(0, &nstate);                       /* set mode */

#if     CBMODE
    ioctl (0, TIOCGETC, &otchars);
    ntchars = otchars;
    ntchars.t_intrc = 07;
    ntchars.t_quitc = -1;
    ntchars.t_startc = 021;
    ntchars.t_stopc = 023;
    ntchars.t_eofc = -1;
    ntchars.t_brkc = -1;
    ioctl (0, TIOCSETC, &ntchars);
#endif
#ifdef _BSD
    ioctl (0, TIOCGLTC, &oltchars);
    memcpy (&nltchars, &oltchars, sizeof (oltchars));
    nltchars.t_suspc = -1;
    nltchars.t_dsuspc = -1;
    nltchars.t_rprntc = -1;
    nltchars.t_flushc = -1;
    nltchars.t_werasc = -1;
    nltchars.t_lnextc = -1;
    ioctl (0, TIOCSLTC, &nltchars);
    /* provide a smaller terminal output buffer so that
       the type ahead detection works better (more often) */
    setbuffer(stdout, &tobuf[0], TBUFSIZ);
    sigset(SIGTSTP,SIG_DFL);    /* set signals so that we can */
    sigset(SIGCONT,rtfrmshell); /* suspend & restart emacs */
#endif  /* _BSD */
#endif
    tputs(LOCKSTR,1,putchar) ;

    /* Success */
    return TRUE ;
}

/*
 * This function gets called just before we go back home to the command
 * interpreter. On VMS it puts the terminal back in a reasonable state.
 * Another no-operation on CPM.
 */
int
TCAPclose(void)
{
    mlerase(MWERASE|MWCURSOR);
#ifdef _MEVMS
    {
        int     status;
        int     iosb[1];
        
        TTflush();
        status = SYS$QIOW(EFN, iochan, IO$_SETMODE, iosb, 0, 0,
                          oldmode, sizeof(oldmode), 0, 0, 0, 0);
        if (status!=SS$_NORMAL || (iosb[0]&0xFFFF)!=SS$_NORMAL)
            meExit(status);
        status = SYS$DASSGN(iochan);
        if (status != SS$_NORMAL)
            meExit(status);
    }
#endif
    tputs(UNLKSTR,1,putchar) ;
#ifdef _USG
#ifdef _TERMIOS
    return tcsetattr (meStdin, TCSAFLUSH, &otermio);
#else
    return ioctl(0, TCSETA, &otermio);  /* restore terminal settings */
#endif
#endif

#if (defined _V7) || (defined _BSD)
    stty(0, &ostate);
#if CBMODE && (defined _BSD)
    ioctl(0, TIOCSETC, &otchars);       /* Place old character into K */
    return ioctl (0, TIOCSLTC, &oltchars);
#endif  /* CBMODE && _BSD */
#endif
}


void
waitForEvent(void)
{
    static int lost=0 ;
    IPIPEBUF *ipipe, *pp ;
    fd_set    select_set;
    int       pfd ;
    
    /* While no input keys and ipipe or alarm signals. */
    for(;;)
    {
        if(TTahead() || (alarmState & 0x10) || 
           isTimerExpired(AUTOS_TIMER_ID) ||
           isTimerExpired(CALLB_TIMER_ID) ||
           isTimerExpired(CURSOR_TIMER_ID) ||
           (sgarbf == TRUE))
            break ;
        TTdieTest() ;
        FD_ZERO(&select_set);
        FD_SET(meStdin, &select_set);
        pfd = meStdin ;
        ipipe = ipipes ;
        while(ipipe != NULL)
        {
            pp = ipipe->next ;
            if(ipipe->pid < 0)
                ipipeRead(ipipe) ;
            else
            {
                FD_SET(ipipe->rfd, &select_set);
                if(ipipe->rfd > pfd)
                    pfd = ipipe->rfd ;
            }
            ipipe = pp ;
        }
        pfd++ ;
        if(select(pfd,&select_set,NULL,NULL,NULL) >= 0)
        {
            ipipe = ipipes ;
            while(ipipe != NULL)
            {
                pp = ipipe->next ;
                /* See if theres anything to read, if so read it */
                if(FD_ISSET(ipipe->rfd,&select_set) || (ipipe->pid < 0))
                {
                    /* reset the lost */
                    lost = 0 ;
                    ipipeRead(ipipe) ;
                }
                ipipe = pp ;
            }
            if(FD_ISSET(meStdin,&select_set))
            {
                /* this is a check to see if we've lost stdin,
                 * if we have there's nothing we can do other than die.
                 * This is common when the X-window is destroyed using
                 * the window manager.
                 */
#ifdef FIONREAD
                int x;      /* holds # of pending chars */
#endif
                if(!
#ifdef FIONREAD
                   /* if ioctl fails don't die! */
                   ((ioctl(meStdin,FIONREAD,&x) < 0) ? 1 : x)
#else
                   ioctl(meStdin, FIORDCHK,0)
#endif
                   )
                {
                    /* Found this test can go wrong in some strange case, which 
                     * is a real bummer as me now dies! as a fix, and I know its
                     * a bit of a bodge, only die is this happens 3 times on the 
                     * trot
                     */
                    if(lost++ == 2)
                        /* If there's nothing to read, yet select flags meStdin as
                         * triggered then we've lost the input - Die...
                         * Unfortunately we must be very careful on what we do, we
                         * cannot write out to the x-window cause its gone, but
                         * meDie takes care of this
                         */
                        meDie() ;
                }
                else
                    lost = 0 ;
            }
        }
        else
            /* Premeture exit - probably a signal for an alarm */
            break;
    }
}

void
TTwaitForChar(void)
{
#if MOUSE
    unsigned short mc ;
    unsigned int   arg ;
    /* If no keys left then if theres currently no mouse timer and
     * theres a button press (No mouse-time key) then check for a
     * time-mouse-? key, if found add a timer start a mouse checking
     */
    if(!isTimerSet(MOUSE_TIMER_ID) &&
       ((mc=(mouseState & MOUSE_STATE_BUTTONS)) != 0))
    {
        mc = ME_SPECIAL | mouseKeyState | (SKEY_mouse_time+mouseKeys[mc]) ;
        /* mouse-time bound ?? */
        if((!TTallKeys && (decode_key(mc,&arg) != -1)) || (TTallKeys & 0x2))
        {
            /* Start a timer and move to timed state 1 */
            /* Start a new timer to clock in at 'delay' intervals */
            /* printf("Setting mouse timer for delay %d\n",delaytime) ;*/
            timerSet(MOUSE_TIMER_ID,-1,delaytime);
        }
    }
#endif
    /* IDLE TIME: Check the idle time events */        
    if(kbdmode == KBD_IDLE)
        /* Check the idle event */
        doIdlePickEvent() ;
    for(;;)
    {
#if (defined _XTERM) && (defined _LINUX)
        if(!(meSystemCfg & meSYSTEM_CONSOLE))
        {
            /* Make a call to XSync(). This ensures that the X-Server has 
             * caught up with the client (us !!). On operations such as 
             * scrolling etc. then the X-Server tends to lag behind giving
             * a very 'rubbery' feel to the scroll bars. This reduces that 
             * effect, allowing the server to process all of our outstanding
             * events (typically xdisplay requests). */
            XSync (xdisplay, FALSE);
        }
#endif
        /* Must only do one at a time else if you get A key while autosaving
         * the key can be proccessed by TTahead and then you sit and wait
         * in TCAPwait
         */
        if(isTimerExpired(AUTOS_TIMER_ID))  /* Alarm expired ?? */
            autoSaveHandler();              /* Initiate an auto save */
        if(isTimerExpired(CALLB_TIMER_ID))  /* Alarm expired ?? */
            callBackHandler();              /* Initiate any callbacks */
        if(isTimerExpired(CURSOR_TIMER_ID)) /* Alarm expired ?? */
            TThandleBlink(0);               /* Initiate a cursor blink */
        if(TTahead())
            break ;
        if(sgarbf == TRUE)
        {
            update(FALSE) ;
            mlerase(MWCLEXEC) ;
        }
        waitForEvent() ;
    }
}


void
TCAPhideCur(void)
{
    /* move the cursor off screen (bottom right) */
    TCAPmove(TTnrow-1,TTncol-1) ;
}

void
TCAPshowCur(void)
{
    if((TTcurr <= TTnrow) && (TTcurc < TTncol))
    {
        TCAPmove(TTcurr,TTcurc) ;
    }
    else
        /* move the cursor off screen (bottom right) */
        TCAPmove(TTnrow-1,TTncol-1) ;
}

#ifdef _TCAPFONT

int vstate=0 ;

#if 0
int
addFont(int f, int n)
{
    extern char *schmPrompts[] ;
    char buff[NPAT];		/* buffer to recieve input into */
    unsigned long *font, mask ;
    int  nn ;
    
    /* Setup the completion */
    mlgsStrList = fontName ;
    mlgsStrListSize = FNTNUMFONTS ;
        
    /* prompt the user and get an answer */
    if(mlreply("Font name",MLLOWER|MLUSER,0,buff,NPAT) == ABORT)
        return FALSE ;
    
    /* test it against the fonts we know */
    for(nn=0; nn < FNTNUMFONTS ; nn++) 
        if(strcmp(buff,fontName[nn]) == 0) 
            break ;
    if(nn == FNTNUMFONTS)
        return mlwrite(MWABORT,"[No such font]");
    
    if(fontComm[nn] == NULL)
    {
        mlwrite(0,"[Termcap does not support %s font]",fontName[nn]) ;
        return TRUE ;
    }
    font = fontMask+(nn*HCTNUM) ;
    /* Get the separate colour indicies from the user. */
    for(nn=0 ; nn<HCTNUM ; nn++)
    {
        if((mlreply(schmPrompts[nn],0,0,buff,NPAT) != TRUE))
            break;
        if(buff[0] == '*')
        {
            if(nn < 2)
                break;
            mask = font[nn-2];
        }
        else 
            mask = meAtoi(buff) ;
            font[nn] = mask ;
    }
    if(nn != HCTNUM)
        return mlwrite(MWABORT|MWPAUSE, "[Invalid font entry]");
    return TRUE ;
}
#endif

void
TCAPfontReset(void)          /* change video status to normal */
{
    if(vstate && (SE != NULL))
    {
        vstate = 0 ;
        putpad(SE);
    }
}

unsigned char
TCAPfontSetScheme(unsigned char fcol)
{
    register unsigned char  bcol=0 ;
    register int ii ;
    
    if(vstate)
        TCAPfontReset() ;
    
    for(ii=0 ; ii<FNTNUMFONTS ; ii++)
    {
        if(fcol & (1<<ii))
        {
            vstate = 1 ;
            bcol |= fontBcol[ii] ;
            putpad(fontComm[ii]) ;
        }
    }
    return bcol ;
}

#endif  /* _TCAPFONT */
#if COLOR

int
TCAPaddColor(unsigned char index, unsigned char r,
              unsigned char g, unsigned char b)
{
    unsigned char *ss ;
    int            ii, jj, idif, jdif ;

    jdif = 256+256+256 ;
    ss = tcapColors ;
    for(ii=0 ; ii<tcapNumColors ; ii++)
    {
        idif  = abs(r - *ss++) ;
        idif += abs(g - *ss++) ;
        idif += abs(b - *ss++) ;
        if(idif < jdif)
        {
            jdif = idif ;
            jj = ii ;
        }
    }

    if(noColors <= index)
    {
        colTable = (unsigned long *) realloc(colTable,
                                             (index+1)*sizeof(unsigned long)) ;
        memset(colTable+noColors,0,
               (index-noColors+1)*sizeof(unsigned long)) ;
        noColors = index+1 ;
    }
    colTable[index] = jj ;

    return TRUE ;
}

void
TCAPcolorSetScheme(unsigned char fcol, unsigned char bcol)
{
    register unsigned long fc=colTable[fcol] ;
    
    if(vstate)
        TCAPfontReset() ;
    
    TCAPcolorSetForeg(fc) ;
    TCAPcolorSetBackg(colTable[bcol]) ;
#ifdef _TCAPFONT
    /* if its a bright color on the fore-ground, switch on bold if we can */
    if((meSystemCfg & meSYSTEM_XANSICOLOR) && (fontComm[FNTBOLD] != NULL))
    {
        if(fc & 0x08)
        {
/*            if(!vstate)*/
/*            {*/
                vstate = 1 ;
                putpad(fontComm[FNTBOLD]) ;
/*            }*/
        }
    }
#endif
}
#endif



void
TTsleep(int  msec, int  intable)
{
    if(intable && ((kbdmode == PLAY) || (clexec == TRUE)))
        return ;

    /* Don't actually need the abs time as this will remain the next alarm */
    timerSet(SLEEP_TIMER_ID,-1,msec);
    do
    {
        if(isTimerExpired(AUTOS_TIMER_ID))  /* Alarm expired ?? */
            autoSaveHandler();              /* Initiate an auto save */
        if(isTimerExpired(CALLB_TIMER_ID))  /* Alarm expired ?? */
            callBackHandler();              /* Initiate any callbacks */
        if(isTimerExpired(CURSOR_TIMER_ID)) /* Alarm expired ?? */
            TThandleBlink(0);               /* Initiate a cursor blink */
        if(intable && TTahead())
            break ;
        waitForEvent() ;
    } while(!isTimerExpired(SLEEP_TIMER_ID)) ;
    timerKill(SLEEP_TIMER_ID) ;             /* Kill off the timer */
}

#if TYPEAH
int
TTahead(void)
{
#ifdef _XTERM
    if(!(meSystemCfg & meSYSTEM_CONSOLE))
    {
        int ii ;
        while((ii=XPending(xdisplay)))
        {
            do
                meXEventHandler() ;
            while(--ii > 0) ;
        }
        /* don't process the timers if we have a key waiting!
         * This is because the timers can generate a lot of timer
         * keys, filling up the input buffer - these are not wanted.
         * By not processing, we leave them there until we need them.
         */
        if(TTnoKeys)
            return TTnoKeys ;

#if MOUSE
        /* If an alarm hCheck the mouse */
        if(isTimerExpired(MOUSE_TIMER_ID))
        {
            unsigned short mc ;
            unsigned int   arg ;
            
            timerClearExpired(MOUSE_TIMER_ID) ;
            mc = ME_SPECIAL | mouseKeyState |
                      (SKEY_mouse_time+mouseKeys[mouseState&MOUSE_STATE_BUTTONS]) ;
            /* mouse-time bound ?? */
            if((!TTallKeys && (decode_key(mc,&arg) != -1)) || (TTallKeys & 0x2))
            {
                /* Timer has expired and timer still bound. Report the key. */
                /* Push the generated keycode into the buffer */
                addKeyToBuffer(mc) ;
                /* Set the new timer and state */
                /* Start a new timer to clock in at 'repeat' intervals */
                /* printf("Setting mouse timer for repeat %d\n",repeattime) ;*/
                timerSet(MOUSE_TIMER_ID,-1,repeattime);
            }
        }
#endif
    }
    else
#endif
    {
        unsigned char cc ;
#ifdef FIONREAD
        int x;      /* holds # of pending chars */
#endif
        /* Pasting in termcap results in lots of keys all at once
         * rather than lose them, keep them there until there enough
         * room in the input key buffer to store them
         */
        while((TTnoKeys != KEYBUFSIZ) &&
#ifdef FIONREAD
              ((ioctl(meStdin,FIONREAD,&x) < 0) ? 0 : x)
#else
              (ioctl(meStdin, FIORDCHK,0))
#endif
              )
            if(read(meStdin,&cc,1) > 0)
                addKeyToBuffer(cc) ;
        if(alarmState & 0x01)
        {
            changeScreenWidth(TRUE,TTnewWid); /* Change width */
            changeScreenDepth(TRUE,TTnewHig); /* Change depth */
        }
        if(TTnoKeys)
            return TTnoKeys ;
    }
    if(isTimerExpired(IDLE_TIMER_ID))
    {
        unsigned int arg;           /* Decode key argument */
        register int index;
        if((index=decode_key(ME_SPECIAL|SKEY_idle_time,&arg)) != -1)
        {
            /* Execute the idle-time key */
            execFuncHidden(ME_SPECIAL|SKEY_idle_time,index,arg) ;
            
            /* Now set the timer for the next */
            timerSet(IDLE_TIMER_ID,-1,idletime);
        }
        else if(decode_key(ME_SPECIAL|SKEY_idle_drop,&arg) != -1)
            meTimerState[IDLE_TIMER_ID] = IDLE_STATE_DROP ;
        else
            meTimerState[IDLE_TIMER_ID] = 0 ;
    }
    return TTnoKeys ;
}
#endif

/*****************************************************************************
 *
 * TCAP SPECIFIC HANDLING FUNCTIONS
 *
 *****************************************************************************/

#ifdef _LINUX
/*
 * colresetcursor()
 * 
 * Unfortunatly LINUX TCAP cursor positioning uses the last output colour
 * written as the cursor colour. Movement of the cursor inherits the 
 * last colour which causes a residue of incorrect colour in the 
 * window. 
 * 
 * For a cursor move under TCAP then change the colour of cursor to the 
 * colour of the character at the cursor position. To do this then perform
 * a destructive write of the characater at the screen position with the 
 * appropriate colour and then restore the cursor to the correct position.
 * 
 * Use the frame store information to determine the text and colour at the 
 * cursor position.
 */
void
TCAPmove(int row, int col)
{
    TCAPgoto(row, col);	/* Go to correct place. */
    
    /* if visible ? */
    if((row <= TTnrow) && (col < TTncol))
    {
        unsigned char fcol;                 /* Foreground colour */
        unsigned char bcol;                 /* Background colour */
        
        /* Extract the colours from the frame store */
#if COLOR
#ifdef _TCAPFONT
        if(meSystemCfg & meSYSTEM_ANSICOLOR)
        {
#endif /* _TCAPFONT */
            fcol = FScolourFore(frameStore[row].colour[col]);
            bcol = FScolourBack(frameStore[row].colour[col]);
            TCAPcolorSetScheme(fcol,bcol) ;
#ifdef _TCAPFONT
        }
        else if(meSystemCfg & meSYSTEM_FONTS)
        {
#endif /* _TCAPFONT */
#endif /* COLOR  */
#ifdef _TCAPFONT
            TCAPfontSetScheme(frameStore[row].colour[col]) ;
#if COLOR
        }
#endif /* COLOR  */
#endif /* _TCAPFONT */
        /* Destructive write of the existing character from the 
         * frame store to the cursor position */
        TCAPputc(frameStore[row].text[col]) ;
#if COLOR
#ifdef _TCAPFONT
        if(meSystemCfg & meSYSTEM_ANSICOLOR)
#endif
            TCAPcolorReset() ;
#endif
#ifdef _TCAPFONT
        if(vstate)
            TCAPfontReset() ;
#endif
#if COLOR
        TCAPgoto(row, col);	        /* Go back to correct place. */
#endif
        TTflush() ;                     /* Force the update */
    }
}
#endif /* _LINUX */




#ifdef _XTERM

/*
 * TThideCur - hide the cursor
 */
void
XTERMhideCur(void)
{
    if((TTcurr <= TTnrow) && (TTcurc < TTncol))
    {
        XGCValues xgcv ;                    /* X Colour values */
        FRAMELINE *flp;                     /* Frame store line pointer */
        char      *cc ;                     /* Current cchar  */
        int        ccol;                    /* Current colour */
        
        flp  = frameStore + TTcurr ;
        cc   = (char *) flp->text+TTcurc ;  /* Get char under cursor */
        ccol = flp->colour[TTcurc] ;        /* Get colour under cursor */
        
        xgcv.foreground = colTable[FScolourFore(ccol)];
        xgcv.background = colTable[FScolourBack(ccol)];
        XChangeGC(xdisplay,xgc,(GCForeground|GCBackground),&xgcv) ;
        if ((meSystemCfg & meSYSTEM_FONTFIX) && !((*cc) & 0xe0))
        {
            static char ss[1]={' '} ;
            XDrawImageString(xdisplay,xwindow,xgc,colToClient(TTcurc),
                             rowToClient(TTcurr)+ascent,ss,1) ;
            XTERMSpecialChar(colToClient(TTcurc),rowToClient(TTcurr),*cc) ;
        }
        else
            XDrawImageString(xdisplay,xwindow,xgc,colToClient(TTcurc),
                             rowToClient(TTcurr)+ascent,cc,1) ;
    }
}

/*
 * TTshowCur - show the cursor
 */
void
XTERMshowCur(void)
{
    if((TTcurr <= TTnrow) && (TTcurc < TTncol))
    {
        XGCValues xgcv ;                    /* X Colour values */
        FRAMELINE *flp;                     /* Frame store line pointer */
        char      *cc ;                     /* Current cchar  */
        int        ccol;                    /* Current colour */
        
        flp  = frameStore + TTcurr ;
        cc   = (char *) flp->text+TTcurc ;  /* Get char under cursor */
        ccol = flp->colour[TTcurc] ;        /* Get colour under cursor */
        
        if(TTfocus)
        {
            xgcv.foreground = colTable[FScolourBack(ccol)];
            xgcv.background = colTable[cursorColor] ;
            XChangeGC(xdisplay,xgc,(GCForeground|GCBackground),&xgcv) ;
            if ((meSystemCfg & meSYSTEM_FONTFIX) && !((*cc) & 0xe0))
            {
                static char ss[1]={' '} ;
                XDrawImageString(xdisplay,xwindow,xgc,colToClient(TTcurc),
                                 rowToClient(TTcurr)+ascent,ss,1) ;
                XTERMSpecialChar(colToClient(TTcurc),rowToClient(TTcurr),*cc) ;
            }
            else
                XDrawImageString(xdisplay,xwindow,xgc,colToClient(TTcurc),
                                 rowToClient(TTcurr)+ascent,cc,1) ;
        }
        else
        {
            xgcv.foreground = colTable[cursorColor] ;
            XChangeGC(xdisplay,xgc,GCForeground,&xgcv) ;
            XDrawRectangle(xdisplay,xwindow,xgc,colToClient(TTcurc),
                           rowToClient(TTcurr),fwidth-1,fdepth-1) ;
        }
    }
}


/*
 * TTdepth
 * Resize the depth of the window. If the resize has been disabled
 * (within the configureNotify event) then do not modify the 
 * window size - this operation is performed elsewhere.
 */
void
TTdepth(int y)
{
    if(!(meSystemCfg & meSYSTEM_CONSOLE) && (disableResize == 0))
    {
        sizeHints.height = fdepth*y ;
        XResizeWindow(xdisplay,xwindow,sizeHints.width,sizeHints.height) ;
    }
}

/*
 * TTwidth
 * Resize the width of the window. If the resize has been disabled
 * (within the configureNotify event) then do not modify the 
 * window size - this operation is performed elsewhere.
 */
void
TTwidth(int x)
{
    if(!(meSystemCfg & meSYSTEM_CONSOLE) && (disableResize == 0))
    {
        sizeHints.width  = fwidth*x ;
        XResizeWindow(xdisplay,xwindow,sizeHints.width,sizeHints.height) ;
    }
}

int
changeFont(int f, int n)
{
    char         buff[MAXBUF] ;            /* Input buffer */ 
    XFontStruct *font ;
    XGCValues    xgcv ;                     /* X Colour values */
    Font         fontId ;

    /* Get the name of the font. If it is specified as default then
     * do not collect the remaining arguments */
    if(mlreply("Font Name", 0, 0, buff, MAXBUF) == ABORT) 
        return FALSE ;
    
    if((font=XLoadQueryFont(xdisplay,buff)) == NULL)
        return FALSE ;
    ascent  = font->ascent ;
    fdepth  = ascent + font->descent ;
    fwidth  = font->max_bounds.width ;
    fhdepth = fdepth >> 1 ;
    fhwidth = fwidth >> 1 ;
    if((fadepth = fwidth+1) > fdepth)
        fadepth = fdepth ;
    fontId  = font->fid ;
    /* Set up the arguments for a resize operation. Because the 
     * font has changed then we need to define the new window
     * base size, minimum size and increment size.
     */
    sizeHints.height = fdepth*(TTnrow+1) ;
    sizeHints.width  = fwidth*TTncol ;
    sizeHints.height_inc = fdepth ;
    sizeHints.width_inc  = fwidth ;
    sizeHints.min_height = fdepth*4 ;
    sizeHints.min_width  = fwidth*10 ;
    sizeHints.base_height = fdepth ;
    sizeHints.base_width  = fwidth ;
    XSetWMNormalHints(xdisplay,xwindow,&sizeHints);
    XResizeWindow(xdisplay,xwindow,sizeHints.width,sizeHints.height) ;

    XFreeFontInfo(NULL,font,1) ;
  
    /* Change to the new font */
    xgcv.font = fontId;
    XChangeGC(xdisplay,xgc,GCFont,&xgcv) ;
    
    sgarbf = TRUE;
    
    return TRUE ;
}

int
XTERMaddColor(unsigned char index, unsigned char r, 
               unsigned char g, unsigned char b)
{
    XColor col ;
    
    if(noColors <= index)
    {
        colTable = (unsigned long *) realloc(colTable,
                                             (index+1)*sizeof(unsigned long)) ;
        memset(colTable+noColors,0,
               (index-noColors+1)*sizeof(unsigned long)) ;
        noColors = index+1 ;
    }
    col.red   = ((unsigned short) r) << 8 ;
    col.green = ((unsigned short) g) << 8 ;
    col.blue  = ((unsigned short) b) << 8 ;
    if(!XAllocColor(xdisplay,xcmap,&col))
    {
        static int noCells=-1 ;
        static unsigned char *cells=NULL ;
        unsigned char *ss ;
        int ii, diff, bDiff=0x30000 ;
        
        
        if(noCells < 0)
        {
            printf("Warning: Failed to allocate colors, looking up closest\n") ;
            if(((noCells = DisplayCells(xdisplay,xscreen)) > 0) &&
               ((cells = malloc(noCells*3*sizeof(unsigned char))) != NULL))
            {
                ii = noCells ;
                ss = cells ;
                for(ii=0 ; ii<noCells ; ii++)
                {
                    col.pixel = ii ;
                    XQueryColor(xdisplay,xcmap,&col) ;
                    *ss++ = (col.red   >> 8) ;
                    *ss++ = (col.green >> 8) ;
                    *ss++ = (col.blue  >> 8) ;
                }
            }
        }
        col.pixel = BlackPixel(xdisplay,xscreen) ;
        if(cells != NULL)
        {
            ii = noCells ;
            ss = cells ;
            for(ii=0 ; ii<noCells ; ii++)
            {
                diff  = abs(((int) *ss++) - ((int) r)) ;
                diff += abs(((int) *ss++) - ((int) g)) ;
                diff += abs(((int) *ss++) - ((int) b)) ;
                if(diff < bDiff)
                {
                    bDiff = diff ;
                    col.pixel = ii ;
                }
            }
            
        }
        XQueryColor(xdisplay,xcmap,&col) ;
        if(!XAllocColor(xdisplay,xcmap,&col))
            printf("Warning: Failed to allocate closest color\n") ;
        
    }
    colTable[index] = col.pixel ;    
    return TRUE ;
}

void TTsetBgcol(void)
{
    /* change the background */
    if(!(meSystemCfg & meSYSTEM_CONSOLE))
        XSetWindowBackground(xdisplay,xwindow,colTable[colSchmTbl[globScheme^1]]);
}

void
TTsetClipboard(void)
{
    clipState &= ~CLIP_TRY_SET ;
    if(!(meSystemCfg & meSYSTEM_CONSOLE) && !(clipState & CLIP_OWNER))
    {
        XSetSelectionOwner(xdisplay,XA_PRIMARY,xwindow,CurrentTime) ;
        clipState |= CLIP_OWNER ;
    }
}

void
TTgetClipboard(void)
{
    clipState &= ~CLIP_TRY_GET ;
    
    if(!(meSystemCfg & meSYSTEM_CONSOLE) && !(clipState & CLIP_OWNER))
    {
        /* Remove the 'Try to get selection' flag. This is really important if increment
         * copy texts are being used. If they are and this flag is set after receiving
         * the initial size, the ksave then take ownership of the block and so we never
         * get the copy text. Take ownership at the end */
        clipState &= ~CLIP_TRY_SET ;
        /* Request for the current Primary string owner to send a
         * SelectionNotify event to us giving the current string
         */
        XConvertSelection(xdisplay,XA_PRIMARY,XA_STRING,meAtoms[meATOM_COPY_TEXT],
                          xwindow,CurrentTime) ;
        /* Must do a flush to ensure the request has gone */
        XFlush(xdisplay) ;
        /* Wait for the returned value, alarmState bit will be set */ 
        while(!TTahead() && !(alarmState & 0x10))
            waitForEvent() ;
        alarmState &= ~0x10 ;
        /* reset the increment clip size to zero (just incase there was an interuption) */
        meClipSize=0 ;
        TTsetClipboard() ;
    }
}

/*
 * TTtitle. Put the name of the buffer into the window frame
 */

void
TTtitleText (char *str)
{
    if(!(meSystemCfg & meSYSTEM_CONSOLE))
    {
        char buf[MAXBUF], *ss ;
    
        strcpy(buf,meName);
        if (str != NULL)
        {
            strcat(buf,": ") ;
            strcat(buf,str) ;
        }
        ss = buf ;
        XStoreName(xdisplay,xwindow,ss);
    }
}

#ifdef _CLIENTSERVER

#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <netinet/in.h>

int meCSSock=-1 ;
int meCCSSock=-1 ;
void
TTopenClientServer (void)
{
    /* If the server has not been created then create it now */
    if(meCSSock == -1)
    {
        struct sockaddr_un cssa ;
        IPIPEBUF *ipipe ;
        BUFFER *bp ;
        meMODE sglobMode ;
        int ii ;
        
        if((meCSSock=socket(AF_UNIX,SOCK_STREAM, 0)) < 0)
        {
            meSystemCfg &= ~meSYSTEM_CLNTSRVR ;
            return ;
        }
        ii = sprintf(cssa.sun_path,"/tmp/mesrv%d",meUid);
        ii += sizeof(cssa.sun_family);
        cssa.sun_family = AF_UNIX;
        
        if(meTestExist((char *) cssa.sun_family) && 
           (connect(meCSSock,(struct sockaddr *)&cssa,ii) >= 0))
        {
            /* theres another me acting as a server, quit! */
            meSystemCfg &= ~meSYSTEM_CLNTSRVR ;
            close(meCSSock) ;
            meCSSock = -1 ;
            return ;
        }
        meUnlink(cssa.sun_path) ;
        if((bind(meCSSock,(struct sockaddr *)&cssa,ii) < 0) ||
           (listen(meCSSock,20) < 0))
        {
            meSystemCfg &= ~meSYSTEM_CLNTSRVR ;
            close(meCSSock) ;
            meCSSock = -1 ;
            return ;
        }
        /* Change socket permissions so only the user can send commands */
        meChmod((char *) cssa.sun_path,0700);
        /* Create the ipipe buffer */
        meModeCopy(sglobMode,globMode) ;
        meModeSet(globMode,MDPIPE) ;
        meModeSet(globMode,MDLOCK) ;
        meModeSet(globMode,MDHIDE) ;
        meModeClear(globMode,MDWRAP) ;
        meModeClear(globMode,MDUNDO) ;
        if(((bp=bfind("*server*",BFND_CREAT)) == NULL) ||
           ((ipipe = meMalloc(sizeof(IPIPEBUF))) == NULL))
        {
            meSystemCfg &= ~meSYSTEM_CLNTSRVR ;
            close(meCSSock) ;
            meCSSock = -1 ;
            return ;
        }
        meModeCopy(globMode,sglobMode) ;
        bp->intFlag |= BIFNODEL|BIFSERVER ;
        ipipe->next = ipipes ;
        ipipe->pid = 0 ;
        ipipe->rfd = meCSSock ;
        ipipe->outWfd = meCSSock ;
        ipipes = ipipe ;
        noIpipes++ ;
        ipipe->bp = bp ;
        /* setup the buffer */
        {
            char buff[MAXBUF] ;
            sprintf(buff,"Client Server: /tmp/mesrv%d",meUid) ;
            addLineToEob(bp,buff) ;     /* Add string */
            addLineToEob(bp,"") ;       /* Add string */
            addLineToEob(bp,"") ;       /* Add string */
            bp->b_dotp = lback(bp->b_linep) ;
            bp->b_doto = 0 ;
            bp->line_no = bp->elineno-1 ;
            alphaMarkSet(bp,'I',bp->b_dotp,bp->b_doto,1) ;
        }
        /* Set up the window dimensions - default to having auto wrap */
        ipipe->flag = 0 ;
        ipipe->strRow = 0 ;
        ipipe->strCol = 0 ;
        ipipe->noRows = 0 ;
        ipipe->noCols = 0 ;
        ipipe->curRow = 0 ;
        ipipe->curRow = bp->line_no ;
        /* get a popup window for the command output */
        ipipeSetSize(curwp,bp) ;
    }
}


void
TTkillClientServer(void)
{
    /* Close & delete the client file */
    if(meCSSock != -1)
    {
        IPIPEBUF *ipipe ;
        char fname[MAXBUF] ;
	
        /* get the ipipe node */
        ipipe = ipipes ;
        while(ipipe != NULL)
        {
            if(ipipe->pid == 0)
                break ;
            ipipe = ipipe->next ;
        }
        if(ipipe != NULL)
        {
            ipipe->bp->intFlag |= BIFBLOW ;
            zotbuf(ipipe->bp,1) ;
        }
        else
            close(meCSSock) ;
        sprintf(fname,"/tmp/mesrv%d",meUid) ;
        meUnlink(fname) ;
        meSystemCfg &= ~meSYSTEM_CLNTSRVR ;
        meCSSock = -1 ;
    }
    if(meCCSSock != -1)
    {
        close(meCSSock) ;
        meCCSSock = -1 ;
    }
}

int
TTconnectClientServer (void)
{
    /* If the server has not been connected then create it now */
    if(meCCSSock == -1)
    {
        struct sockaddr_un cssa ;
        int ii ;

        if((meCCSSock=socket(AF_UNIX,SOCK_STREAM, 0)) < 0)
            return 0 ;
        
        ii = sizeof(cssa.sun_family);
        ii += sprintf(cssa.sun_path,"/tmp/mesrv%d",meUid);
        cssa.sun_family = AF_UNIX;
        
        if(connect(meCCSSock,(struct sockaddr *)&cssa,ii) < 0)
        {
            close(meCCSSock) ;
            meCCSSock = -1 ;
            return 0 ;
        }
    }
    return 1 ;
}
void
TTsendClientServer(char *line)
{
    if(meCCSSock >= 0)
    {
        int ii, ll=strlen(line) ;
        while(ll)
        {
            if((ii=write(meCCSSock,line,ll)) < 0)
                return ;
            ll -= ii ;
            line += ii ;
        }
    }
}
#endif
#endif	/* _XTERM */

