/* -*- C -*- ****************************************************************
 *
 *  			Copyright 1999 Jasspa.
 *			      All Rights Reserved
 *
 *
 *  System        : Microsoft Window's private data structures.
 *  Module        : MicroEmacs.
 *
 *  File Name     : 
 *  Revision      : 1.0
 *  Author        : Jon Green
 *  Created       : Mon May 24 14:12:57 1999
 *  Last Modified : <280599.0804>
 *
 *  Description	  : Export shared definitions of the windows specific
 *                  environment with the different windows specific source
 *                  files.
 *
 *  Notes
 *
 *  History
 *	
 ****************************************************************************
 *
 * Copyright (c) 1999 Jasspa.
 * 
 * All Rights Reserved.
 * 
 * This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
 * reproduced,  translated,  or  reduced to any  electronic  medium or machine
 * readable form without prior written consent from Jasspa.
 * 
 * Mailto: jasspa@geocities.com
 *
 ****************************************************************************/

#ifndef __WINTERM_H__
#define __WINTERM_H__

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/* Font type settings */
extern int ttfont;                      /* Font attributes */
#define TTFONT_OEM      0x01            /* This is an OEM font */
#define TTFONT_SPECIAL  0x02            /* Special font is loaded */
#define TTFONT_REMAP    0x04            /* Special font, Remap to ASCII */
#define TTFONT_BASE_RES 0x10            /* Base resource is loaded */
#define TTFONT_NO1_RES  0x20            /* Number 1 font resource loaded */
#define TTFONT_NO2_RES  0x40            /* Number 2 font resource loaded */
#define TTFONT_NO3_RES  0x80            /* Number 3 font resource loaded */
#define TTFONT_RES      0xf0            /* Font resources */

/* speChars. ASCII conversion table of the special characters. */
extern char speChars [32];

/* The metrics associated with a charcter cell */
typedef struct
{
    int sizeX;                          /* Character cell size in X width */
    int sizeY;                          /* Character cell size in Y (height) */
    int midX;                           /* Mid position of the cell */
    int midY;                           /* Mid position of the cell */
}  CharMetrics;

/* Paint the windows special characters */
extern void WinSpecialChar (HDC hdc, CharMetrics *cm, int x, int y, char cc, COLORREF fcol);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif
#endif /* __WINTERM_H__ */



